/* contacts-vcard-type-mapping.c generated by valac 0.56.4, the Vala compiler
 * generated from contacts-vcard-type-mapping.vala, do not modify */

/*
 * Copyright (C) 2018 Niels De Graef <nielsdegraef@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include "contactscore.h"

#define CONTACTS_VCARD_TYPE_MAPPING_MAX_TYPES 3

#define CONTACTS_TYPE_VCARD_TYPE_MAPPING (contacts_vcard_type_mapping_get_type ())
typedef struct _ContactsVcardTypeMapping ContactsVcardTypeMapping;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ContactsVcardTypeMapping {
	const gchar* name;
	const gchar* types[3];
};

VALA_EXTERN GType contacts_vcard_type_mapping_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ContactsVcardTypeMapping* contacts_vcard_type_mapping_dup (const ContactsVcardTypeMapping* self);
VALA_EXTERN void contacts_vcard_type_mapping_free (ContactsVcardTypeMapping* self);
VALA_EXTERN gboolean contacts_vcard_type_mapping_contains (ContactsVcardTypeMapping *self,
                                               const gchar* type);
static gboolean contacts_vcard_type_mapping_types_are_equal (const gchar* a,
                                                      const gchar* b);
VALA_EXTERN gboolean contacts_vcard_type_mapping_matches (ContactsVcardTypeMapping *self,
                                              GeeCollection* types);

/** Returns whether the mapping contains the given vcard type. */
gboolean
contacts_vcard_type_mapping_contains (ContactsVcardTypeMapping *self,
                                      const gchar* type)
{
	gboolean result;
#line 31 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (type != NULL, FALSE);
#line 59 "contacts-vcard-type-mapping.c"
	{
		gint i = 0;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
		i = 0;
#line 64 "contacts-vcard-type-mapping.c"
		{
			gboolean _tmp0_ = FALSE;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
			_tmp0_ = TRUE;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
			while (TRUE) {
#line 71 "contacts-vcard-type-mapping.c"
				gboolean _tmp2_ = FALSE;
				const gchar* _tmp4_;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp0_) {
#line 76 "contacts-vcard-type-mapping.c"
					gint _tmp1_;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp1_ = i;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
					i = _tmp1_ + 1;
#line 82 "contacts-vcard-type-mapping.c"
				}
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
				_tmp0_ = FALSE;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
				if (i < CONTACTS_VCARD_TYPE_MAPPING_MAX_TYPES) {
#line 88 "contacts-vcard-type-mapping.c"
					const gchar* _tmp3_;
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp3_ = (*self).types[i];
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = _tmp3_ != NULL;
#line 94 "contacts-vcard-type-mapping.c"
				} else {
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = FALSE;
#line 98 "contacts-vcard-type-mapping.c"
				}
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp2_) {
#line 32 "../src/core/contacts-vcard-type-mapping.vala"
					break;
#line 104 "contacts-vcard-type-mapping.c"
				}
#line 33 "../src/core/contacts-vcard-type-mapping.vala"
				_tmp4_ = (*self).types[i];
#line 33 "../src/core/contacts-vcard-type-mapping.vala"
				if (contacts_vcard_type_mapping_types_are_equal (_tmp4_, type)) {
#line 34 "../src/core/contacts-vcard-type-mapping.vala"
					result = TRUE;
#line 34 "../src/core/contacts-vcard-type-mapping.vala"
					return result;
#line 114 "contacts-vcard-type-mapping.c"
				}
			}
		}
	}
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
	result = FALSE;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
	return result;
#line 123 "contacts-vcard-type-mapping.c"
}

/**
   * Checks whether all items in the VcardTypeMapping are in the specified @types.
   * Even though there might be other values in @types, we ignore them.
   *
   * For example: [ HOME, FOO, PREF, BLAH ] should match the [ HOME ] VCard
   * type, but not [ HOME, FAX ]
   */
gboolean
contacts_vcard_type_mapping_matches (ContactsVcardTypeMapping *self,
                                     GeeCollection* types)
{
	gboolean result;
#line 45 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (types != NULL, FALSE);
#line 140 "contacts-vcard-type-mapping.c"
	{
		gint i = 0;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
		i = 0;
#line 145 "contacts-vcard-type-mapping.c"
		{
			gboolean _tmp0_ = FALSE;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
			_tmp0_ = TRUE;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
			while (TRUE) {
#line 152 "contacts-vcard-type-mapping.c"
				gboolean _tmp2_ = FALSE;
				gboolean occurs_in_list = FALSE;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp0_) {
#line 157 "contacts-vcard-type-mapping.c"
					gint _tmp1_;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp1_ = i;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
					i = _tmp1_ + 1;
#line 163 "contacts-vcard-type-mapping.c"
				}
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
				_tmp0_ = FALSE;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
				if (i < CONTACTS_VCARD_TYPE_MAPPING_MAX_TYPES) {
#line 169 "contacts-vcard-type-mapping.c"
					const gchar* _tmp3_;
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp3_ = (*self).types[i];
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = _tmp3_ != NULL;
#line 175 "contacts-vcard-type-mapping.c"
				} else {
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = FALSE;
#line 179 "contacts-vcard-type-mapping.c"
				}
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp2_) {
#line 46 "../src/core/contacts-vcard-type-mapping.vala"
					break;
#line 185 "contacts-vcard-type-mapping.c"
				}
#line 47 "../src/core/contacts-vcard-type-mapping.vala"
				occurs_in_list = FALSE;
#line 189 "contacts-vcard-type-mapping.c"
				{
					GeeIterator* _type_it = NULL;
					GeeIterator* _tmp4_;
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp4_ = gee_iterable_iterator ((GeeIterable*) types);
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
					_type_it = _tmp4_;
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
					while (TRUE) {
#line 199 "contacts-vcard-type-mapping.c"
						GeeIterator* _tmp5_;
						gchar* type = NULL;
						GeeIterator* _tmp6_;
						gpointer _tmp7_;
						const gchar* _tmp8_;
						const gchar* _tmp9_;
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp5_ = _type_it;
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
						if (!gee_iterator_next (_tmp5_)) {
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
							break;
#line 212 "contacts-vcard-type-mapping.c"
						}
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp6_ = _type_it;
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp7_ = gee_iterator_get (_tmp6_);
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
						type = (gchar*) _tmp7_;
#line 49 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp8_ = type;
#line 49 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp9_ = (*self).types[i];
#line 49 "../src/core/contacts-vcard-type-mapping.vala"
						if (contacts_vcard_type_mapping_types_are_equal (_tmp8_, _tmp9_)) {
#line 50 "../src/core/contacts-vcard-type-mapping.vala"
							occurs_in_list = TRUE;
#line 51 "../src/core/contacts-vcard-type-mapping.vala"
							_g_free0 (type);
#line 51 "../src/core/contacts-vcard-type-mapping.vala"
							break;
#line 232 "contacts-vcard-type-mapping.c"
						}
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
						_g_free0 (type);
#line 236 "contacts-vcard-type-mapping.c"
					}
#line 48 "../src/core/contacts-vcard-type-mapping.vala"
					_g_object_unref0 (_type_it);
#line 240 "contacts-vcard-type-mapping.c"
				}
#line 55 "../src/core/contacts-vcard-type-mapping.vala"
				if (!occurs_in_list) {
#line 56 "../src/core/contacts-vcard-type-mapping.vala"
					result = FALSE;
#line 56 "../src/core/contacts-vcard-type-mapping.vala"
					return result;
#line 248 "contacts-vcard-type-mapping.c"
				}
			}
		}
	}
#line 58 "../src/core/contacts-vcard-type-mapping.vala"
	result = TRUE;
#line 58 "../src/core/contacts-vcard-type-mapping.vala"
	return result;
#line 257 "contacts-vcard-type-mapping.c"
}

static gboolean
contacts_vcard_type_mapping_types_are_equal (const gchar* a,
                                             const gchar* b)
{
	gboolean result;
#line 61 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 61 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 62 "../src/core/contacts-vcard-type-mapping.vala"
	result = g_ascii_strcasecmp (a, b) == 0;
#line 62 "../src/core/contacts-vcard-type-mapping.vala"
	return result;
#line 273 "contacts-vcard-type-mapping.c"
}

ContactsVcardTypeMapping*
contacts_vcard_type_mapping_dup (const ContactsVcardTypeMapping* self)
{
	ContactsVcardTypeMapping* dup;
#line 25 "../src/core/contacts-vcard-type-mapping.vala"
	dup = g_new0 (ContactsVcardTypeMapping, 1);
#line 25 "../src/core/contacts-vcard-type-mapping.vala"
	memcpy (dup, self, sizeof (ContactsVcardTypeMapping));
#line 25 "../src/core/contacts-vcard-type-mapping.vala"
	return dup;
#line 286 "contacts-vcard-type-mapping.c"
}

void
contacts_vcard_type_mapping_free (ContactsVcardTypeMapping* self)
{
#line 25 "../src/core/contacts-vcard-type-mapping.vala"
	g_free (self);
#line 294 "contacts-vcard-type-mapping.c"
}

 G_GNUC_NO_INLINE static GType
contacts_vcard_type_mapping_get_type_once (void)
{
	GType contacts_vcard_type_mapping_type_id;
	contacts_vcard_type_mapping_type_id = g_boxed_type_register_static ("ContactsVcardTypeMapping", (GBoxedCopyFunc) contacts_vcard_type_mapping_dup, (GBoxedFreeFunc) contacts_vcard_type_mapping_free);
	return contacts_vcard_type_mapping_type_id;
}

GType
contacts_vcard_type_mapping_get_type (void)
{
	static volatile gsize contacts_vcard_type_mapping_type_id__once = 0;
	if (g_once_init_enter (&contacts_vcard_type_mapping_type_id__once)) {
		GType contacts_vcard_type_mapping_type_id;
		contacts_vcard_type_mapping_type_id = contacts_vcard_type_mapping_get_type_once ();
		g_once_init_leave (&contacts_vcard_type_mapping_type_id__once, contacts_vcard_type_mapping_type_id);
	}
	return contacts_vcard_type_mapping_type_id__once;
}

