/* contacts-crop-dialog.c generated by valac 0.56.4, the Vala compiler
 * generated from contacts-crop-dialog.vala, do not modify */

/*
 * Copyright (C) 2018 Elias Entrup <elias-git@flump.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <cc-crop-area.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CONTACTS_TYPE_CROP_DIALOG (contacts_crop_dialog_get_type ())
#define CONTACTS_CROP_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_CROP_DIALOG, ContactsCropDialog))
#define CONTACTS_CROP_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_CROP_DIALOG, ContactsCropDialogClass))
#define CONTACTS_IS_CROP_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_CROP_DIALOG))
#define CONTACTS_IS_CROP_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_CROP_DIALOG))
#define CONTACTS_CROP_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_CROP_DIALOG, ContactsCropDialogClass))

typedef struct _ContactsCropDialog ContactsCropDialog;
typedef struct _ContactsCropDialogClass ContactsCropDialogClass;
typedef struct _ContactsCropDialogPrivate ContactsCropDialogPrivate;
enum  {
	CONTACTS_CROP_DIALOG_0_PROPERTY,
	CONTACTS_CROP_DIALOG_NUM_PROPERTIES
};
static GParamSpec* contacts_crop_dialog_properties[CONTACTS_CROP_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	CONTACTS_CROP_DIALOG_CROPPED_SIGNAL,
	CONTACTS_CROP_DIALOG_NUM_SIGNALS
};
static guint contacts_crop_dialog_signals[CONTACTS_CROP_DIALOG_NUM_SIGNALS] = {0};

struct _ContactsCropDialog {
	GtkWindow parent_instance;
	ContactsCropDialogPrivate * priv;
};

struct _ContactsCropDialogClass {
	GtkWindowClass parent_class;
};

struct _ContactsCropDialogPrivate {
	CcCropArea* crop_area;
};

static gint ContactsCropDialog_private_offset;
static gpointer contacts_crop_dialog_parent_class = NULL;

VALA_EXTERN GType contacts_crop_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsCropDialog, g_object_unref)
VALA_EXTERN ContactsCropDialog* contacts_crop_dialog_new_for_pixbuf (GdkPixbuf* pixbuf,
                                                         GtkWindow* parent);
VALA_EXTERN ContactsCropDialog* contacts_crop_dialog_construct_for_pixbuf (GType object_type,
                                                               GdkPixbuf* pixbuf,
                                                               GtkWindow* parent);
static void contacts_crop_dialog_on_crop (ContactsCropDialog* self,
                                   const gchar* action_name,
                                   GVariant* param);
VALA_EXTERN ContactsCropDialog* contacts_crop_dialog_new (void);
VALA_EXTERN ContactsCropDialog* contacts_crop_dialog_construct (GType object_type);
static GObject * contacts_crop_dialog_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void contacts_crop_dialog_finalize (GObject * obj);
static GType contacts_crop_dialog_get_type_once (void);

static inline gpointer
contacts_crop_dialog_get_instance_private (ContactsCropDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsCropDialog_private_offset);
}

ContactsCropDialog*
contacts_crop_dialog_construct_for_pixbuf (GType object_type,
                                           GdkPixbuf* pixbuf,
                                           GtkWindow* parent)
{
	ContactsCropDialog * self = NULL;
	CcCropArea* _tmp0_;
	GdkTexture* _tmp1_;
	GdkTexture* _tmp2_;
#line 37 "../src/contacts-crop-dialog.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 39 "../src/contacts-crop-dialog.vala"
	self = (ContactsCropDialog*) g_object_new (object_type, "transient-for", parent, NULL);
#line 41 "../src/contacts-crop-dialog.vala"
	_tmp0_ = self->priv->crop_area;
#line 41 "../src/contacts-crop-dialog.vala"
	_tmp1_ = gdk_texture_new_for_pixbuf (pixbuf);
#line 41 "../src/contacts-crop-dialog.vala"
	_tmp2_ = _tmp1_;
#line 41 "../src/contacts-crop-dialog.vala"
	cc_crop_area_set_paintable (_tmp0_, (GdkPaintable*) _tmp2_);
#line 41 "../src/contacts-crop-dialog.vala"
	_g_object_unref0 (_tmp2_);
#line 37 "../src/contacts-crop-dialog.vala"
	return self;
#line 128 "contacts-crop-dialog.c"
}

ContactsCropDialog*
contacts_crop_dialog_new_for_pixbuf (GdkPixbuf* pixbuf,
                                     GtkWindow* parent)
{
#line 37 "../src/contacts-crop-dialog.vala"
	return contacts_crop_dialog_construct_for_pixbuf (CONTACTS_TYPE_CROP_DIALOG, pixbuf, parent);
#line 137 "contacts-crop-dialog.c"
}

static void
contacts_crop_dialog_on_crop (ContactsCropDialog* self,
                              const gchar* action_name,
                              GVariant* param)
{
	CcCropArea* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
#line 44 "../src/contacts-crop-dialog.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/contacts-crop-dialog.vala"
	g_return_if_fail (action_name != NULL);
#line 45 "../src/contacts-crop-dialog.vala"
	_tmp0_ = self->priv->crop_area;
#line 45 "../src/contacts-crop-dialog.vala"
	_tmp1_ = cc_crop_area_create_pixbuf (_tmp0_);
#line 45 "../src/contacts-crop-dialog.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/contacts-crop-dialog.vala"
	g_signal_emit (self, contacts_crop_dialog_signals[CONTACTS_CROP_DIALOG_CROPPED_SIGNAL], 0, _tmp2_);
#line 45 "../src/contacts-crop-dialog.vala"
	_g_object_unref0 (_tmp2_);
#line 46 "../src/contacts-crop-dialog.vala"
	gtk_window_destroy ((GtkWindow*) self);
#line 164 "contacts-crop-dialog.c"
}

ContactsCropDialog*
contacts_crop_dialog_construct (GType object_type)
{
	ContactsCropDialog * self = NULL;
#line 19 "../src/contacts-crop-dialog.vala"
	self = (ContactsCropDialog*) g_object_new (object_type, NULL);
#line 19 "../src/contacts-crop-dialog.vala"
	return self;
#line 175 "contacts-crop-dialog.c"
}

ContactsCropDialog*
contacts_crop_dialog_new (void)
{
#line 19 "../src/contacts-crop-dialog.vala"
	return contacts_crop_dialog_construct (CONTACTS_TYPE_CROP_DIALOG);
#line 183 "contacts-crop-dialog.c"
}

static GObject *
contacts_crop_dialog_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ContactsCropDialog * self;
	CcCropArea* _tmp0_;
	CcCropArea* _tmp1_;
	CcCropArea* _tmp2_;
	CcCropArea* _tmp3_;
	CcCropArea* _tmp4_;
#line 29 "../src/contacts-crop-dialog.vala"
	parent_class = G_OBJECT_CLASS (contacts_crop_dialog_parent_class);
#line 29 "../src/contacts-crop-dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 29 "../src/contacts-crop-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_CROP_DIALOG, ContactsCropDialog);
#line 30 "../src/contacts-crop-dialog.vala"
	_tmp0_ = (CcCropArea*) cc_crop_area_new ();
#line 30 "../src/contacts-crop-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 30 "../src/contacts-crop-dialog.vala"
	_g_object_unref0 (self->priv->crop_area);
#line 30 "../src/contacts-crop-dialog.vala"
	self->priv->crop_area = _tmp0_;
#line 31 "../src/contacts-crop-dialog.vala"
	_tmp1_ = self->priv->crop_area;
#line 31 "../src/contacts-crop-dialog.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp1_, TRUE);
#line 32 "../src/contacts-crop-dialog.vala"
	_tmp2_ = self->priv->crop_area;
#line 32 "../src/contacts-crop-dialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 33 "../src/contacts-crop-dialog.vala"
	_tmp3_ = self->priv->crop_area;
#line 33 "../src/contacts-crop-dialog.vala"
	cc_crop_area_set_min_size (_tmp3_, 48, 48);
#line 34 "../src/contacts-crop-dialog.vala"
	_tmp4_ = self->priv->crop_area;
#line 34 "../src/contacts-crop-dialog.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp4_);
#line 29 "../src/contacts-crop-dialog.vala"
	return obj;
#line 231 "contacts-crop-dialog.c"
}

static void
contacts_crop_dialog_class_init (ContactsCropDialogClass * klass,
                                 gpointer klass_data)
{
#line 19 "../src/contacts-crop-dialog.vala"
	contacts_crop_dialog_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/contacts-crop-dialog.vala"
	g_type_class_adjust_private_offset (klass, &ContactsCropDialog_private_offset);
#line 19 "../src/contacts-crop-dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = contacts_crop_dialog_constructor;
#line 19 "../src/contacts-crop-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_crop_dialog_finalize;
#line 19 "../src/contacts-crop-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Contacts/ui/contacts-crop-dialog.ui");
#line 19 "../src/contacts-crop-dialog.vala"
	contacts_crop_dialog_signals[CONTACTS_CROP_DIALOG_CROPPED_SIGNAL] = g_signal_new ("cropped", CONTACTS_TYPE_CROP_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gdk_pixbuf_get_type ());
#line 26 "../src/contacts-crop-dialog.vala"
	gtk_widget_class_install_action (GTK_WIDGET_CLASS (klass), "crop", NULL, (GtkWidgetActionActivateFunc) contacts_crop_dialog_on_crop);
#line 252 "contacts-crop-dialog.c"
}

static void
contacts_crop_dialog_instance_init (ContactsCropDialog * self,
                                    gpointer klass)
{
#line 19 "../src/contacts-crop-dialog.vala"
	self->priv = contacts_crop_dialog_get_instance_private (self);
#line 19 "../src/contacts-crop-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 263 "contacts-crop-dialog.c"
}

static void
contacts_crop_dialog_finalize (GObject * obj)
{
	ContactsCropDialog * self;
#line 19 "../src/contacts-crop-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_CROP_DIALOG, ContactsCropDialog);
#line 21 "../src/contacts-crop-dialog.vala"
	_g_object_unref0 (self->priv->crop_area);
#line 19 "../src/contacts-crop-dialog.vala"
	G_OBJECT_CLASS (contacts_crop_dialog_parent_class)->finalize (obj);
#line 276 "contacts-crop-dialog.c"
}

 G_GNUC_NO_INLINE static GType
contacts_crop_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsCropDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_crop_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsCropDialog), 0, (GInstanceInitFunc) contacts_crop_dialog_instance_init, NULL };
	GType contacts_crop_dialog_type_id;
	contacts_crop_dialog_type_id = g_type_register_static (gtk_window_get_type (), "ContactsCropDialog", &g_define_type_info, 0);
	ContactsCropDialog_private_offset = g_type_add_instance_private (contacts_crop_dialog_type_id, sizeof (ContactsCropDialogPrivate));
	return contacts_crop_dialog_type_id;
}

GType
contacts_crop_dialog_get_type (void)
{
	static volatile gsize contacts_crop_dialog_type_id__once = 0;
	if (g_once_init_enter (&contacts_crop_dialog_type_id__once)) {
		GType contacts_crop_dialog_type_id;
		contacts_crop_dialog_type_id = contacts_crop_dialog_get_type_once ();
		g_once_init_leave (&contacts_crop_dialog_type_id__once, contacts_crop_dialog_type_id);
	}
	return contacts_crop_dialog_type_id__once;
}

