/* contacts-io-vcard-parser.c generated by valac 0.56.4, the Vala compiler
 * generated from contacts-io-vcard-parser.vala, do not modify */

/*
 * Copyright (C) 2021 Niels De Graef <nielsdegraef@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include "contactscore.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libebook-contacts/libebook-contacts.h>
#include <folks/folks.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CONTACTS_IO_TYPE_PARSER (contacts_io_parser_get_type ())
#define CONTACTS_IO_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_IO_TYPE_PARSER, ContactsIoParser))
#define CONTACTS_IO_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_IO_TYPE_PARSER, ContactsIoParserClass))
#define CONTACTS_IO_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_IO_TYPE_PARSER))
#define CONTACTS_IO_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_IO_TYPE_PARSER))
#define CONTACTS_IO_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_IO_TYPE_PARSER, ContactsIoParserClass))

typedef struct _ContactsIoParser ContactsIoParser;
typedef struct _ContactsIoParserClass ContactsIoParserClass;
typedef struct _ContactsIoParserPrivate ContactsIoParserPrivate;

#define CONTACTS_IO_TYPE_VCARD_PARSER (contacts_io_vcard_parser_get_type ())
#define CONTACTS_IO_VCARD_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_IO_TYPE_VCARD_PARSER, ContactsIoVCardParser))
#define CONTACTS_IO_VCARD_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_IO_TYPE_VCARD_PARSER, ContactsIoVCardParserClass))
#define CONTACTS_IO_IS_VCARD_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_IO_TYPE_VCARD_PARSER))
#define CONTACTS_IO_IS_VCARD_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_IO_TYPE_VCARD_PARSER))
#define CONTACTS_IO_VCARD_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_IO_TYPE_VCARD_PARSER, ContactsIoVCardParserClass))

typedef struct _ContactsIoVCardParser ContactsIoVCardParser;
typedef struct _ContactsIoVCardParserClass ContactsIoVCardParserClass;
typedef struct _ContactsIoVCardParserPrivate ContactsIoVCardParserPrivate;
enum  {
	CONTACTS_IO_VCARD_PARSER_0_PROPERTY,
	CONTACTS_IO_VCARD_PARSER_NUM_PROPERTIES
};
static GParamSpec* contacts_io_vcard_parser_properties[CONTACTS_IO_VCARD_PARSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define __vala_EContactDate_free0(var) ((var == NULL) ? NULL : (var = (_vala_EContactDate_free (var), NULL)))

struct _ContactsIoParser {
	GObject parent_instance;
	ContactsIoParserPrivate * priv;
};

struct _ContactsIoParserClass {
	GObjectClass parent_class;
	ContactsContact** (*parse) (ContactsIoParser* self, GInputStream* input, gint* result_length1, GError** error);
};

struct _ContactsIoVCardParser {
	ContactsIoParser parent_instance;
	ContactsIoVCardParserPrivate * priv;
};

struct _ContactsIoVCardParserClass {
	ContactsIoParserClass parent_class;
};

static gpointer contacts_io_vcard_parser_parent_class = NULL;

VALA_EXTERN GType contacts_io_parser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsIoParser, g_object_unref)
VALA_EXTERN GType contacts_io_vcard_parser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsIoVCardParser, g_object_unref)
VALA_EXTERN ContactsContact** contacts_io_parser_parse (ContactsIoParser* self,
                                            GInputStream* input,
                                            gint* result_length1,
                                            GError** error);
VALA_EXTERN ContactsIoVCardParser* contacts_io_vcard_parser_new (void);
VALA_EXTERN ContactsIoVCardParser* contacts_io_vcard_parser_construct (GType object_type);
VALA_EXTERN ContactsIoParser* contacts_io_parser_construct (GType object_type);
static ContactsContact** contacts_io_vcard_parser_real_parse (ContactsIoParser* base,
                                                       GInputStream* input,
                                                       gint* result_length1,
                                                       GError** error);
static void _g_object_unref0_ (gpointer var);
static void contacts_io_vcard_parser_handle_fn (ContactsIoVCardParser* self,
                                         ContactsContact* contact,
                                         EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_n (ContactsIoVCardParser* self,
                                        ContactsContact* contact,
                                        EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_nickname (ContactsIoVCardParser* self,
                                               ContactsContact* contact,
                                               EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_bday (ContactsIoVCardParser* self,
                                           ContactsContact* contact,
                                           EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_adr (ContactsIoVCardParser* self,
                                          ContactsContact* contact,
                                          EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_tel (ContactsIoVCardParser* self,
                                          ContactsContact* contact,
                                          EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_email (ContactsIoVCardParser* self,
                                            ContactsContact* contact,
                                            EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_title (ContactsIoVCardParser* self,
                                            ContactsContact* contact,
                                            EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_org (ContactsIoVCardParser* self,
                                          ContactsContact* contact,
                                          EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_note (ContactsIoVCardParser* self,
                                           ContactsContact* contact,
                                           EVCardAttribute* attr);
static void contacts_io_vcard_parser_handle_url (ContactsIoVCardParser* self,
                                          ContactsContact* contact,
                                          EVCardAttribute* attr);
static void _vala_EContactDate_free (EContactDate* self);
static ContactsBinChunkChild* contacts_io_vcard_parser_add_chunk_child_for_property (ContactsIoVCardParser* self,
                                                                              ContactsContact* contact,
                                                                              const gchar* property_name);
static void contacts_io_vcard_parser_add_params (ContactsIoVCardParser* self,
                                          ContactsBinChunkChild* chunk_child,
                                          EVCardAttribute* attr);
static GType contacts_io_vcard_parser_get_type_once (void);

ContactsIoVCardParser*
contacts_io_vcard_parser_construct (GType object_type)
{
	ContactsIoVCardParser * self = NULL;
#line 25 "../src/io/contacts-io-vcard-parser.vala"
	self = (ContactsIoVCardParser*) contacts_io_parser_construct (object_type);
#line 25 "../src/io/contacts-io-vcard-parser.vala"
	return self;
#line 160 "contacts-io-vcard-parser.c"
}

ContactsIoVCardParser*
contacts_io_vcard_parser_new (void)
{
#line 25 "../src/io/contacts-io-vcard-parser.vala"
	return contacts_io_vcard_parser_construct (CONTACTS_IO_TYPE_VCARD_PARSER);
#line 168 "contacts-io-vcard-parser.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1563 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1564 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1564 "glib-2.0.vapi"
	res_length1 = -1;
#line 1564 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1565 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1565 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1565 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1566 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1566 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1566 "glib-2.0.vapi"
	if (result_length1) {
#line 1566 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 205 "contacts-io-vcard-parser.c"
	}
#line 1566 "glib-2.0.vapi"
	result = _tmp2_;
#line 1566 "glib-2.0.vapi"
	return result;
#line 211 "contacts-io-vcard-parser.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 37 "../src/io/contacts-io-vcard-parser.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 219 "contacts-io-vcard-parser.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 243 "contacts-io-vcard-parser.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 251 "contacts-io-vcard-parser.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 257 "contacts-io-vcard-parser.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 285 "contacts-io-vcard-parser.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 291 "contacts-io-vcard-parser.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 297 "contacts-io-vcard-parser.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 301 "contacts-io-vcard-parser.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 309 "contacts-io-vcard-parser.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 313 "contacts-io-vcard-parser.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 325 "contacts-io-vcard-parser.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 108 "../src/io/contacts-io-vcard-parser.vala"
	return self ? g_object_ref (self) : NULL;
#line 333 "contacts-io-vcard-parser.c"
}

static ContactsContact**
contacts_io_vcard_parser_real_parse (ContactsIoParser* base,
                                     GInputStream* input,
                                     gint* result_length1,
                                     GError** error)
{
	ContactsIoVCardParser * self;
	GMemoryOutputStream* memory_stream = NULL;
	GMemoryOutputStream* _tmp0_;
	GMemoryOutputStream* _tmp1_;
	GMemoryOutputStream* _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	guint8* _tmp5_;
	gint _tmp5__length1;
	GMemoryOutputStream* _tmp6_;
	gchar* input_str = NULL;
	GMemoryOutputStream* _tmp7_;
	guint8* _tmp8_;
	gchar* _tmp9_;
	GPtrArray* _result_ = NULL;
	GPtrArray* _tmp10_;
	gint begin_index = 0;
	const gchar* _tmp11_;
	GPtrArray* _tmp57_;
	gsize _tmp58_ = 0;
	gpointer* _tmp59_;
	ContactsContact** _tmp60_;
	gint _tmp60__length1;
	GError* _inner_error0_ = NULL;
	ContactsContact** result;
#line 28 "../src/io/contacts-io-vcard-parser.vala"
	self = (ContactsIoVCardParser*) base;
#line 28 "../src/io/contacts-io-vcard-parser.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 31 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = (GMemoryOutputStream*) g_memory_output_stream_new_resizable ();
#line 31 "../src/io/contacts-io-vcard-parser.vala"
	memory_stream = _tmp0_;
#line 32 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = memory_stream;
#line 32 "../src/io/contacts-io-vcard-parser.vala"
	g_output_stream_splice ((GOutputStream*) _tmp1_, input, 0, NULL, &_inner_error0_);
#line 32 "../src/io/contacts-io-vcard-parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../src/io/contacts-io-vcard-parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 32 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (memory_stream);
#line 32 "../src/io/contacts-io-vcard-parser.vala"
		return NULL;
#line 388 "contacts-io-vcard-parser.c"
	}
#line 33 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = memory_stream;
#line 33 "../src/io/contacts-io-vcard-parser.vala"
	_tmp3_ = string_get_data ("\0", &_tmp4_);
#line 33 "../src/io/contacts-io-vcard-parser.vala"
	_tmp3__length1 = _tmp4_;
#line 33 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = _tmp3_;
#line 33 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5__length1 = _tmp3__length1;
#line 33 "../src/io/contacts-io-vcard-parser.vala"
	g_output_stream_write ((GOutputStream*) _tmp2_, _tmp5_, (gsize) _tmp5__length1, NULL, &_inner_error0_);
#line 33 "../src/io/contacts-io-vcard-parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "../src/io/contacts-io-vcard-parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 33 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (memory_stream);
#line 33 "../src/io/contacts-io-vcard-parser.vala"
		return NULL;
#line 410 "contacts-io-vcard-parser.c"
	}
#line 34 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = memory_stream;
#line 34 "../src/io/contacts-io-vcard-parser.vala"
	g_output_stream_close ((GOutputStream*) _tmp6_, NULL, &_inner_error0_);
#line 34 "../src/io/contacts-io-vcard-parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 34 "../src/io/contacts-io-vcard-parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 34 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (memory_stream);
#line 34 "../src/io/contacts-io-vcard-parser.vala"
		return NULL;
#line 424 "contacts-io-vcard-parser.c"
	}
#line 35 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = memory_stream;
#line 35 "../src/io/contacts-io-vcard-parser.vala"
	_tmp8_ = g_memory_output_stream_get_data (_tmp7_);
#line 35 "../src/io/contacts-io-vcard-parser.vala"
	_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 35 "../src/io/contacts-io-vcard-parser.vala"
	input_str = _tmp9_;
#line 37 "../src/io/contacts-io-vcard-parser.vala"
	_tmp10_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 37 "../src/io/contacts-io-vcard-parser.vala"
	_result_ = _tmp10_;
#line 40 "../src/io/contacts-io-vcard-parser.vala"
	_tmp11_ = input_str;
#line 40 "../src/io/contacts-io-vcard-parser.vala"
	begin_index = string_index_of (_tmp11_, "BEGIN:VCARD", 0);
#line 41 "../src/io/contacts-io-vcard-parser.vala"
	while (TRUE) {
#line 444 "contacts-io-vcard-parser.c"
		gint end_vcard_index = 0;
		const gchar* _tmp12_;
		gint end_index = 0;
		gint _tmp13_;
		gint _tmp14_;
		gchar* vcard_str = NULL;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		EVCard* vcard = NULL;
		const gchar* _tmp17_;
		EVCard* _tmp18_;
		GList* vcard_attrs = NULL;
		EVCard* _tmp19_;
		GList* _tmp20_;
		GList* _tmp21_;
		ContactsContact* contact = NULL;
		ContactsContact* _tmp22_;
		GList* _tmp23_;
		GPtrArray* _tmp53_;
		ContactsContact* _tmp54_;
		ContactsContact* _tmp55_;
		const gchar* _tmp56_;
#line 41 "../src/io/contacts-io-vcard-parser.vala"
		if (!(begin_index != -1)) {
#line 41 "../src/io/contacts-io-vcard-parser.vala"
			break;
#line 471 "contacts-io-vcard-parser.c"
		}
#line 43 "../src/io/contacts-io-vcard-parser.vala"
		_tmp12_ = input_str;
#line 43 "../src/io/contacts-io-vcard-parser.vala"
		end_vcard_index = string_index_of (_tmp12_, "END:VCARD", begin_index + 1);
#line 44 "../src/io/contacts-io-vcard-parser.vala"
		_tmp13_ = strlen ("END:VCARD");
#line 44 "../src/io/contacts-io-vcard-parser.vala"
		_tmp14_ = _tmp13_;
#line 44 "../src/io/contacts-io-vcard-parser.vala"
		end_index = end_vcard_index + _tmp14_;
#line 45 "../src/io/contacts-io-vcard-parser.vala"
		_tmp15_ = input_str;
#line 45 "../src/io/contacts-io-vcard-parser.vala"
		_tmp16_ = string_slice (_tmp15_, (glong) begin_index, (glong) end_index);
#line 45 "../src/io/contacts-io-vcard-parser.vala"
		vcard_str = _tmp16_;
#line 48 "../src/io/contacts-io-vcard-parser.vala"
		_tmp17_ = vcard_str;
#line 48 "../src/io/contacts-io-vcard-parser.vala"
		_tmp18_ = e_vcard_new_from_string (_tmp17_);
#line 48 "../src/io/contacts-io-vcard-parser.vala"
		vcard = _tmp18_;
#line 51 "../src/io/contacts-io-vcard-parser.vala"
		_tmp19_ = vcard;
#line 51 "../src/io/contacts-io-vcard-parser.vala"
		_tmp20_ = e_vcard_get_attributes (_tmp19_);
#line 51 "../src/io/contacts-io-vcard-parser.vala"
		vcard_attrs = _tmp20_;
#line 52 "../src/io/contacts-io-vcard-parser.vala"
		_tmp21_ = vcard_attrs;
#line 52 "../src/io/contacts-io-vcard-parser.vala"
		g_debug ("contacts-io-vcard-parser.vala:52: Got %u attributes in this vcard", g_list_length (_tmp21_));
#line 54 "../src/io/contacts-io-vcard-parser.vala"
		_tmp22_ = contacts_contact_new_empty ();
#line 54 "../src/io/contacts-io-vcard-parser.vala"
		contact = _tmp22_;
#line 56 "../src/io/contacts-io-vcard-parser.vala"
		_tmp23_ = vcard_attrs;
#line 511 "contacts-io-vcard-parser.c"
		{
			GList* attr_collection = NULL;
			GList* attr_it = NULL;
#line 56 "../src/io/contacts-io-vcard-parser.vala"
			attr_collection = _tmp23_;
#line 56 "../src/io/contacts-io-vcard-parser.vala"
			for (attr_it = attr_collection; attr_it != NULL; attr_it = attr_it->next) {
#line 519 "contacts-io-vcard-parser.c"
				EVCardAttribute* attr = NULL;
#line 56 "../src/io/contacts-io-vcard-parser.vala"
				attr = (EVCardAttribute*) attr_it->data;
#line 523 "contacts-io-vcard-parser.c"
				{
					EVCardAttribute* _tmp24_;
					const gchar* _tmp25_;
					const gchar* _tmp26_;
					GQuark _tmp28_ = 0U;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label0 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label1 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label2 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label3 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label4 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label5 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label6 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label7 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label8 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label9 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					static GQuark _tmp27_label10 = 0;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					_tmp24_ = attr;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					_tmp25_ = e_vcard_attribute_get_name (_tmp24_);
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					_tmp26_ = _tmp25_;
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					_tmp28_ = (NULL == _tmp26_) ? 0 : g_quark_from_string (_tmp26_);
#line 57 "../src/io/contacts-io-vcard-parser.vala"
					if (_tmp28_ == ((0 != _tmp27_label0) ? _tmp27_label0 : (_tmp27_label0 = g_quark_from_static_string (EVC_FN)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 563 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp29_;
								EVCardAttribute* _tmp30_;
#line 60 "../src/io/contacts-io-vcard-parser.vala"
								_tmp29_ = contact;
#line 60 "../src/io/contacts-io-vcard-parser.vala"
								_tmp30_ = attr;
#line 60 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_fn (self, _tmp29_, _tmp30_);
#line 61 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 576 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label1) ? _tmp27_label1 : (_tmp27_label1 = g_quark_from_static_string (EVC_N)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 582 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp31_;
								EVCardAttribute* _tmp32_;
#line 63 "../src/io/contacts-io-vcard-parser.vala"
								_tmp31_ = contact;
#line 63 "../src/io/contacts-io-vcard-parser.vala"
								_tmp32_ = attr;
#line 63 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_n (self, _tmp31_, _tmp32_);
#line 64 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 595 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label2) ? _tmp27_label2 : (_tmp27_label2 = g_quark_from_static_string (EVC_NICKNAME)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 601 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp33_;
								EVCardAttribute* _tmp34_;
#line 66 "../src/io/contacts-io-vcard-parser.vala"
								_tmp33_ = contact;
#line 66 "../src/io/contacts-io-vcard-parser.vala"
								_tmp34_ = attr;
#line 66 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_nickname (self, _tmp33_, _tmp34_);
#line 67 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 614 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label3) ? _tmp27_label3 : (_tmp27_label3 = g_quark_from_static_string (EVC_BDAY)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 620 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp35_;
								EVCardAttribute* _tmp36_;
#line 74 "../src/io/contacts-io-vcard-parser.vala"
								_tmp35_ = contact;
#line 74 "../src/io/contacts-io-vcard-parser.vala"
								_tmp36_ = attr;
#line 74 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_bday (self, _tmp35_, _tmp36_);
#line 75 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 633 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label4) ? _tmp27_label4 : (_tmp27_label4 = g_quark_from_static_string (EVC_ADR)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 639 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp37_;
								EVCardAttribute* _tmp38_;
#line 78 "../src/io/contacts-io-vcard-parser.vala"
								_tmp37_ = contact;
#line 78 "../src/io/contacts-io-vcard-parser.vala"
								_tmp38_ = attr;
#line 78 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_adr (self, _tmp37_, _tmp38_);
#line 79 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 652 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label5) ? _tmp27_label5 : (_tmp27_label5 = g_quark_from_static_string (EVC_TEL)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 658 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp39_;
								EVCardAttribute* _tmp40_;
#line 82 "../src/io/contacts-io-vcard-parser.vala"
								_tmp39_ = contact;
#line 82 "../src/io/contacts-io-vcard-parser.vala"
								_tmp40_ = attr;
#line 82 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_tel (self, _tmp39_, _tmp40_);
#line 83 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 671 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label6) ? _tmp27_label6 : (_tmp27_label6 = g_quark_from_static_string (EVC_EMAIL)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 677 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp41_;
								EVCardAttribute* _tmp42_;
#line 85 "../src/io/contacts-io-vcard-parser.vala"
								_tmp41_ = contact;
#line 85 "../src/io/contacts-io-vcard-parser.vala"
								_tmp42_ = attr;
#line 85 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_email (self, _tmp41_, _tmp42_);
#line 86 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 690 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label7) ? _tmp27_label7 : (_tmp27_label7 = g_quark_from_static_string (EVC_TITLE)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 696 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp43_;
								EVCardAttribute* _tmp44_;
#line 89 "../src/io/contacts-io-vcard-parser.vala"
								_tmp43_ = contact;
#line 89 "../src/io/contacts-io-vcard-parser.vala"
								_tmp44_ = attr;
#line 89 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_title (self, _tmp43_, _tmp44_);
#line 90 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 709 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label8) ? _tmp27_label8 : (_tmp27_label8 = g_quark_from_static_string (EVC_ORG)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 715 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp45_;
								EVCardAttribute* _tmp46_;
#line 92 "../src/io/contacts-io-vcard-parser.vala"
								_tmp45_ = contact;
#line 92 "../src/io/contacts-io-vcard-parser.vala"
								_tmp46_ = attr;
#line 92 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_org (self, _tmp45_, _tmp46_);
#line 93 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 728 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label9) ? _tmp27_label9 : (_tmp27_label9 = g_quark_from_static_string (EVC_NOTE)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 734 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp47_;
								EVCardAttribute* _tmp48_;
#line 96 "../src/io/contacts-io-vcard-parser.vala"
								_tmp47_ = contact;
#line 96 "../src/io/contacts-io-vcard-parser.vala"
								_tmp48_ = attr;
#line 96 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_note (self, _tmp47_, _tmp48_);
#line 97 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 747 "contacts-io-vcard-parser.c"
							}
						}
					} else if (_tmp28_ == ((0 != _tmp27_label10) ? _tmp27_label10 : (_tmp27_label10 = g_quark_from_static_string (EVC_URL)))) {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 753 "contacts-io-vcard-parser.c"
							default:
							{
								ContactsContact* _tmp49_;
								EVCardAttribute* _tmp50_;
#line 99 "../src/io/contacts-io-vcard-parser.vala"
								_tmp49_ = contact;
#line 99 "../src/io/contacts-io-vcard-parser.vala"
								_tmp50_ = attr;
#line 99 "../src/io/contacts-io-vcard-parser.vala"
								contacts_io_vcard_parser_handle_url (self, _tmp49_, _tmp50_);
#line 100 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 766 "contacts-io-vcard-parser.c"
							}
						}
					} else {
#line 57 "../src/io/contacts-io-vcard-parser.vala"
						switch (0) {
#line 772 "contacts-io-vcard-parser.c"
							default:
							{
								EVCardAttribute* _tmp51_;
								const gchar* _tmp52_;
#line 103 "../src/io/contacts-io-vcard-parser.vala"
								_tmp51_ = attr;
#line 103 "../src/io/contacts-io-vcard-parser.vala"
								_tmp52_ = e_vcard_attribute_get_name (_tmp51_);
#line 103 "../src/io/contacts-io-vcard-parser.vala"
								g_debug ("contacts-io-vcard-parser.vala:103: Unknown property name '%s'", _tmp52_);
#line 104 "../src/io/contacts-io-vcard-parser.vala"
								break;
#line 785 "contacts-io-vcard-parser.c"
							}
						}
					}
				}
			}
		}
#line 108 "../src/io/contacts-io-vcard-parser.vala"
		_tmp53_ = _result_;
#line 108 "../src/io/contacts-io-vcard-parser.vala"
		_tmp54_ = contact;
#line 108 "../src/io/contacts-io-vcard-parser.vala"
		_tmp55_ = _g_object_ref0 (_tmp54_);
#line 108 "../src/io/contacts-io-vcard-parser.vala"
		g_ptr_array_add (_tmp53_, _tmp55_);
#line 110 "../src/io/contacts-io-vcard-parser.vala"
		_tmp56_ = input_str;
#line 110 "../src/io/contacts-io-vcard-parser.vala"
		begin_index = string_index_of (_tmp56_, "BEGIN:VCARD", end_index);
#line 41 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (contact);
#line 41 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (vcard);
#line 41 "../src/io/contacts-io-vcard-parser.vala"
		_g_free0 (vcard_str);
#line 810 "contacts-io-vcard-parser.c"
	}
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	_tmp57_ = _result_;
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	_tmp59_ = g_ptr_array_steal (_tmp57_, &_tmp58_);
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	_tmp60_ = _tmp59_;
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	_tmp60__length1 = _tmp58_;
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	if (result_length1) {
#line 113 "../src/io/contacts-io-vcard-parser.vala"
		*result_length1 = _tmp60__length1;
#line 824 "contacts-io-vcard-parser.c"
	}
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	result = _tmp60_;
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	_g_ptr_array_unref0 (_result_);
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (input_str);
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (memory_stream);
#line 113 "../src/io/contacts-io-vcard-parser.vala"
	return result;
#line 836 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_fn (ContactsIoVCardParser* self,
                                    ContactsContact* contact,
                                    EVCardAttribute* attr)
{
	gchar* full_name = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	ContactsChunk* _tmp2_ = NULL;
	ContactsChunk* _tmp3_;
	ContactsChunk* chunk = NULL;
	ContactsChunk* _tmp5_;
	ContactsFullNameChunk* fn_chunk = NULL;
	const gchar* _tmp6_;
#line 117 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 117 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 118 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 118 "../src/io/contacts-io-vcard-parser.vala"
	full_name = _tmp0_;
#line 119 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = full_name;
#line 119 "../src/io/contacts-io-vcard-parser.vala"
	g_debug ("contacts-io-vcard-parser.vala:119: Got FN '%s'", _tmp1_);
#line 123 "../src/io/contacts-io-vcard-parser.vala"
	_tmp3_ = contacts_contact_get_most_relevant_chunk (contact, "full-name", TRUE);
#line 123 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = _tmp3_;
#line 123 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp2_ == NULL) {
#line 873 "contacts-io-vcard-parser.c"
		ContactsChunk* _tmp4_;
#line 124 "../src/io/contacts-io-vcard-parser.vala"
		_tmp4_ = contacts_contact_create_chunk (contact, "full-name", NULL);
#line 124 "../src/io/contacts-io-vcard-parser.vala"
		_tmp2_ = _tmp4_;
#line 879 "contacts-io-vcard-parser.c"
	}
#line 123 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = _g_object_ref0 (_tmp2_);
#line 123 "../src/io/contacts-io-vcard-parser.vala"
	chunk = _tmp5_;
#line 125 "../src/io/contacts-io-vcard-parser.vala"
	fn_chunk = G_TYPE_CHECK_INSTANCE_CAST (chunk, CONTACTS_TYPE_FULL_NAME_CHUNK, ContactsFullNameChunk);
#line 126 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = full_name;
#line 126 "../src/io/contacts-io-vcard-parser.vala"
	contacts_full_name_chunk_set_full_name (fn_chunk, _tmp6_);
#line 117 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (chunk);
#line 117 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (full_name);
#line 895 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_n (ContactsIoVCardParser* self,
                                   ContactsContact* contact,
                                   EVCardAttribute* attr)
{
	GList* values = NULL;
	GList* _tmp0_;
	ContactsStructuredNameChunk* sn_chunk = NULL;
	ContactsChunk* _tmp1_;
	ContactsStructuredNameChunk* _tmp2_;
	const gchar* _tmp3_ = NULL;
	GList* _tmp4_;
	gconstpointer _tmp5_;
	ContactsStructuredNameChunk* _tmp6_;
	FolksStructuredName* _tmp7_;
	FolksStructuredName* _tmp8_;
	const gchar* _tmp9_ = NULL;
	GList* _tmp10_;
	gconstpointer _tmp11_;
	ContactsStructuredNameChunk* _tmp12_;
	FolksStructuredName* _tmp13_;
	FolksStructuredName* _tmp14_;
	const gchar* _tmp15_ = NULL;
	GList* _tmp16_;
	gconstpointer _tmp17_;
	ContactsStructuredNameChunk* _tmp18_;
	FolksStructuredName* _tmp19_;
	FolksStructuredName* _tmp20_;
	const gchar* _tmp21_ = NULL;
	GList* _tmp22_;
	gconstpointer _tmp23_;
	ContactsStructuredNameChunk* _tmp24_;
	FolksStructuredName* _tmp25_;
	FolksStructuredName* _tmp26_;
	const gchar* _tmp27_ = NULL;
	GList* _tmp28_;
	gconstpointer _tmp29_;
	ContactsStructuredNameChunk* _tmp30_;
	FolksStructuredName* _tmp31_;
	FolksStructuredName* _tmp32_;
#line 130 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 130 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 131 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_values (attr);
#line 131 "../src/io/contacts-io-vcard-parser.vala"
	values = _tmp0_;
#line 137 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = contacts_contact_create_chunk (contact, "structured-name", NULL);
#line 137 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, CONTACTS_TYPE_STRUCTURED_NAME_CHUNK, ContactsStructuredNameChunk));
#line 137 "../src/io/contacts-io-vcard-parser.vala"
	sn_chunk = _tmp2_;
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = values;
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = g_list_nth_data (_tmp4_, (guint) 0);
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	_tmp3_ = (const gchar*) _tmp5_;
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp3_ == NULL) {
#line 138 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = "";
#line 964 "contacts-io-vcard-parser.c"
	}
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = sn_chunk;
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = contacts_structured_name_chunk_get_structured_name (_tmp6_);
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	_tmp8_ = _tmp7_;
#line 138 "../src/io/contacts-io-vcard-parser.vala"
	folks_structured_name_set_family_name (_tmp8_, _tmp3_);
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	_tmp10_ = values;
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	_tmp11_ = g_list_nth_data (_tmp10_, (guint) 1);
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	_tmp9_ = (const gchar*) _tmp11_;
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp9_ == NULL) {
#line 139 "../src/io/contacts-io-vcard-parser.vala"
		_tmp9_ = "";
#line 984 "contacts-io-vcard-parser.c"
	}
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	_tmp12_ = sn_chunk;
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	_tmp13_ = contacts_structured_name_chunk_get_structured_name (_tmp12_);
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	_tmp14_ = _tmp13_;
#line 139 "../src/io/contacts-io-vcard-parser.vala"
	folks_structured_name_set_given_name (_tmp14_, _tmp9_);
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	_tmp16_ = values;
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	_tmp17_ = g_list_nth_data (_tmp16_, (guint) 2);
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	_tmp15_ = (const gchar*) _tmp17_;
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp15_ == NULL) {
#line 140 "../src/io/contacts-io-vcard-parser.vala"
		_tmp15_ = "";
#line 1004 "contacts-io-vcard-parser.c"
	}
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	_tmp18_ = sn_chunk;
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	_tmp19_ = contacts_structured_name_chunk_get_structured_name (_tmp18_);
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	_tmp20_ = _tmp19_;
#line 140 "../src/io/contacts-io-vcard-parser.vala"
	folks_structured_name_set_additional_names (_tmp20_, _tmp15_);
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	_tmp22_ = values;
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	_tmp23_ = g_list_nth_data (_tmp22_, (guint) 3);
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	_tmp21_ = (const gchar*) _tmp23_;
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp21_ == NULL) {
#line 141 "../src/io/contacts-io-vcard-parser.vala"
		_tmp21_ = "";
#line 1024 "contacts-io-vcard-parser.c"
	}
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	_tmp24_ = sn_chunk;
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	_tmp25_ = contacts_structured_name_chunk_get_structured_name (_tmp24_);
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	_tmp26_ = _tmp25_;
#line 141 "../src/io/contacts-io-vcard-parser.vala"
	folks_structured_name_set_prefixes (_tmp26_, _tmp21_);
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	_tmp28_ = values;
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	_tmp29_ = g_list_nth_data (_tmp28_, (guint) 4);
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	_tmp27_ = (const gchar*) _tmp29_;
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp27_ == NULL) {
#line 142 "../src/io/contacts-io-vcard-parser.vala"
		_tmp27_ = "";
#line 1044 "contacts-io-vcard-parser.c"
	}
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	_tmp30_ = sn_chunk;
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	_tmp31_ = contacts_structured_name_chunk_get_structured_name (_tmp30_);
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	_tmp32_ = _tmp31_;
#line 142 "../src/io/contacts-io-vcard-parser.vala"
	folks_structured_name_set_suffixes (_tmp32_, _tmp27_);
#line 130 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (sn_chunk);
#line 1056 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_nickname (ContactsIoVCardParser* self,
                                          ContactsContact* contact,
                                          EVCardAttribute* attr)
{
	gchar* nickname = NULL;
	gchar* _tmp0_;
	ContactsNicknameChunk* nick_chunk = NULL;
	ContactsChunk* _tmp1_;
	ContactsNicknameChunk* _tmp2_;
#line 145 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 145 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 146 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 146 "../src/io/contacts-io-vcard-parser.vala"
	nickname = _tmp0_;
#line 147 "../src/io/contacts-io-vcard-parser.vala"
	g_debug ("contacts-io-vcard-parser.vala:147: Got nickname '%s'", nickname);
#line 149 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = contacts_contact_create_chunk (contact, "nickname", NULL);
#line 149 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, CONTACTS_TYPE_NICKNAME_CHUNK, ContactsNicknameChunk));
#line 149 "../src/io/contacts-io-vcard-parser.vala"
	nick_chunk = _tmp2_;
#line 150 "../src/io/contacts-io-vcard-parser.vala"
	contacts_nickname_chunk_set_nickname (nick_chunk, nickname);
#line 145 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (nick_chunk);
#line 145 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (nickname);
#line 1093 "contacts-io-vcard-parser.c"
}

static void
_vala_EContactDate_free (EContactDate* self)
{
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	g_boxed_free (e_contact_date_get_type (), self);
#line 1101 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_bday (ContactsIoVCardParser* self,
                                      ContactsContact* contact,
                                      EVCardAttribute* attr)
{
	gchar* bday = NULL;
	gchar* _tmp0_;
	EContactDate* e_date = NULL;
	EContactDate* _tmp1_;
	GDateTime* datetime = NULL;
	GDateTime* _tmp2_;
	ContactsBirthdayChunk* bd_chunk = NULL;
	ContactsChunk* _tmp3_;
	ContactsBirthdayChunk* _tmp4_;
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 155 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 155 "../src/io/contacts-io-vcard-parser.vala"
	bday = _tmp0_;
#line 156 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = e_contact_date_from_string (bday);
#line 156 "../src/io/contacts-io-vcard-parser.vala"
	e_date = _tmp1_;
#line 157 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = g_date_time_new_utc ((gint) e_date->year, (gint) e_date->month, (gint) e_date->day, 0, 0, 0.0);
#line 157 "../src/io/contacts-io-vcard-parser.vala"
	datetime = _tmp2_;
#line 162 "../src/io/contacts-io-vcard-parser.vala"
	_tmp3_ = contacts_contact_create_chunk (contact, "birthday", NULL);
#line 162 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, CONTACTS_TYPE_BIRTHDAY_CHUNK, ContactsBirthdayChunk));
#line 162 "../src/io/contacts-io-vcard-parser.vala"
	bd_chunk = _tmp4_;
#line 163 "../src/io/contacts-io-vcard-parser.vala"
	contacts_birthday_chunk_set_birthday (bd_chunk, datetime);
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (bd_chunk);
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	_g_date_time_unref0 (datetime);
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	__vala_EContactDate_free0 (e_date);
#line 154 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (bday);
#line 1152 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_email (ContactsIoVCardParser* self,
                                       ContactsContact* contact,
                                       EVCardAttribute* attr)
{
	gchar* email = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	ContactsBinChunkChild* child = NULL;
	ContactsBinChunkChild* _tmp4_;
	ContactsBinChunkChild* _tmp5_;
	const gchar* _tmp6_;
	ContactsBinChunkChild* _tmp7_;
#line 166 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 166 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 167 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 167 "../src/io/contacts-io-vcard-parser.vala"
	email = _tmp0_;
#line 168 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = email;
#line 168 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp2_ == NULL) {
#line 168 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = TRUE;
#line 1185 "contacts-io-vcard-parser.c"
	} else {
		const gchar* _tmp3_;
#line 168 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = email;
#line 168 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
#line 1192 "contacts-io-vcard-parser.c"
	}
#line 168 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp1_) {
#line 169 "../src/io/contacts-io-vcard-parser.vala"
		_g_free0 (email);
#line 169 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1200 "contacts-io-vcard-parser.c"
	}
#line 171 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = contacts_io_vcard_parser_add_chunk_child_for_property (self, contact, "email-addresses");
#line 171 "../src/io/contacts-io-vcard-parser.vala"
	child = _tmp4_;
#line 172 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = child;
#line 172 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = email;
#line 172 "../src/io/contacts-io-vcard-parser.vala"
	contacts_email_address_set_raw_address (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, CONTACTS_TYPE_EMAIL_ADDRESS, ContactsEmailAddress), _tmp6_);
#line 173 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = child;
#line 173 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_add_params (self, _tmp7_, attr);
#line 166 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (child);
#line 166 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (email);
#line 1220 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_tel (ContactsIoVCardParser* self,
                                     ContactsContact* contact,
                                     EVCardAttribute* attr)
{
	gchar* phone_nr = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	ContactsBinChunkChild* child = NULL;
	ContactsBinChunkChild* _tmp4_;
	ContactsBinChunkChild* _tmp5_;
	const gchar* _tmp6_;
	ContactsBinChunkChild* _tmp7_;
#line 176 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 176 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 177 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 177 "../src/io/contacts-io-vcard-parser.vala"
	phone_nr = _tmp0_;
#line 178 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = phone_nr;
#line 178 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp2_ == NULL) {
#line 178 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = TRUE;
#line 1253 "contacts-io-vcard-parser.c"
	} else {
		const gchar* _tmp3_;
#line 178 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = phone_nr;
#line 178 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
#line 1260 "contacts-io-vcard-parser.c"
	}
#line 178 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp1_) {
#line 179 "../src/io/contacts-io-vcard-parser.vala"
		_g_free0 (phone_nr);
#line 179 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1268 "contacts-io-vcard-parser.c"
	}
#line 181 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = contacts_io_vcard_parser_add_chunk_child_for_property (self, contact, "phone-numbers");
#line 181 "../src/io/contacts-io-vcard-parser.vala"
	child = _tmp4_;
#line 182 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = child;
#line 182 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = phone_nr;
#line 182 "../src/io/contacts-io-vcard-parser.vala"
	contacts_phone_set_raw_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, CONTACTS_TYPE_PHONE, ContactsPhone), _tmp6_);
#line 183 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = child;
#line 183 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_add_params (self, _tmp7_, attr);
#line 176 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (child);
#line 176 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (phone_nr);
#line 1288 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_adr (ContactsIoVCardParser* self,
                                     ContactsContact* contact,
                                     EVCardAttribute* attr)
{
	GList* values = NULL;
	GList* _tmp0_;
	ContactsBinChunkChild* child = NULL;
	ContactsBinChunkChild* _tmp1_;
	FolksPostalAddress* address = NULL;
	ContactsBinChunkChild* _tmp2_;
	FolksPostalAddress* _tmp3_;
	FolksPostalAddress* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GList* _tmp6_;
	gconstpointer _tmp7_;
	FolksPostalAddress* _tmp8_;
	const gchar* _tmp9_ = NULL;
	GList* _tmp10_;
	gconstpointer _tmp11_;
	FolksPostalAddress* _tmp12_;
	const gchar* _tmp13_ = NULL;
	GList* _tmp14_;
	gconstpointer _tmp15_;
	FolksPostalAddress* _tmp16_;
	const gchar* _tmp17_ = NULL;
	GList* _tmp18_;
	gconstpointer _tmp19_;
	FolksPostalAddress* _tmp20_;
	const gchar* _tmp21_ = NULL;
	GList* _tmp22_;
	gconstpointer _tmp23_;
	FolksPostalAddress* _tmp24_;
	const gchar* _tmp25_ = NULL;
	GList* _tmp26_;
	gconstpointer _tmp27_;
	FolksPostalAddress* _tmp28_;
	const gchar* _tmp29_ = NULL;
	GList* _tmp30_;
	gconstpointer _tmp31_;
	FolksPostalAddress* _tmp32_;
	ContactsBinChunkChild* _tmp33_;
#line 187 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 187 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 188 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_values (attr);
#line 188 "../src/io/contacts-io-vcard-parser.vala"
	values = _tmp0_;
#line 190 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = contacts_io_vcard_parser_add_chunk_child_for_property (self, contact, "postal-addresses");
#line 190 "../src/io/contacts-io-vcard-parser.vala"
	child = _tmp1_;
#line 191 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = child;
#line 191 "../src/io/contacts-io-vcard-parser.vala"
	_tmp3_ = contacts_address_get_address (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, CONTACTS_TYPE_ADDRESS, ContactsAddress));
#line 191 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = _tmp3_;
#line 191 "../src/io/contacts-io-vcard-parser.vala"
	address = _tmp4_;
#line 198 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = values;
#line 198 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = g_list_nth_data (_tmp6_, (guint) 0);
#line 198 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = (const gchar*) _tmp7_;
#line 198 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp5_ == NULL) {
#line 198 "../src/io/contacts-io-vcard-parser.vala"
		_tmp5_ = "";
#line 1365 "contacts-io-vcard-parser.c"
	}
#line 198 "../src/io/contacts-io-vcard-parser.vala"
	_tmp8_ = address;
#line 198 "../src/io/contacts-io-vcard-parser.vala"
	folks_postal_address_set_po_box (_tmp8_, _tmp5_);
#line 199 "../src/io/contacts-io-vcard-parser.vala"
	_tmp10_ = values;
#line 199 "../src/io/contacts-io-vcard-parser.vala"
	_tmp11_ = g_list_nth_data (_tmp10_, (guint) 1);
#line 199 "../src/io/contacts-io-vcard-parser.vala"
	_tmp9_ = (const gchar*) _tmp11_;
#line 199 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp9_ == NULL) {
#line 199 "../src/io/contacts-io-vcard-parser.vala"
		_tmp9_ = "";
#line 1381 "contacts-io-vcard-parser.c"
	}
#line 199 "../src/io/contacts-io-vcard-parser.vala"
	_tmp12_ = address;
#line 199 "../src/io/contacts-io-vcard-parser.vala"
	folks_postal_address_set_extension (_tmp12_, _tmp9_);
#line 200 "../src/io/contacts-io-vcard-parser.vala"
	_tmp14_ = values;
#line 200 "../src/io/contacts-io-vcard-parser.vala"
	_tmp15_ = g_list_nth_data (_tmp14_, (guint) 2);
#line 200 "../src/io/contacts-io-vcard-parser.vala"
	_tmp13_ = (const gchar*) _tmp15_;
#line 200 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp13_ == NULL) {
#line 200 "../src/io/contacts-io-vcard-parser.vala"
		_tmp13_ = "";
#line 1397 "contacts-io-vcard-parser.c"
	}
#line 200 "../src/io/contacts-io-vcard-parser.vala"
	_tmp16_ = address;
#line 200 "../src/io/contacts-io-vcard-parser.vala"
	folks_postal_address_set_street (_tmp16_, _tmp13_);
#line 201 "../src/io/contacts-io-vcard-parser.vala"
	_tmp18_ = values;
#line 201 "../src/io/contacts-io-vcard-parser.vala"
	_tmp19_ = g_list_nth_data (_tmp18_, (guint) 3);
#line 201 "../src/io/contacts-io-vcard-parser.vala"
	_tmp17_ = (const gchar*) _tmp19_;
#line 201 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp17_ == NULL) {
#line 201 "../src/io/contacts-io-vcard-parser.vala"
		_tmp17_ = "";
#line 1413 "contacts-io-vcard-parser.c"
	}
#line 201 "../src/io/contacts-io-vcard-parser.vala"
	_tmp20_ = address;
#line 201 "../src/io/contacts-io-vcard-parser.vala"
	folks_postal_address_set_locality (_tmp20_, _tmp17_);
#line 202 "../src/io/contacts-io-vcard-parser.vala"
	_tmp22_ = values;
#line 202 "../src/io/contacts-io-vcard-parser.vala"
	_tmp23_ = g_list_nth_data (_tmp22_, (guint) 4);
#line 202 "../src/io/contacts-io-vcard-parser.vala"
	_tmp21_ = (const gchar*) _tmp23_;
#line 202 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp21_ == NULL) {
#line 202 "../src/io/contacts-io-vcard-parser.vala"
		_tmp21_ = "";
#line 1429 "contacts-io-vcard-parser.c"
	}
#line 202 "../src/io/contacts-io-vcard-parser.vala"
	_tmp24_ = address;
#line 202 "../src/io/contacts-io-vcard-parser.vala"
	folks_postal_address_set_region (_tmp24_, _tmp21_);
#line 203 "../src/io/contacts-io-vcard-parser.vala"
	_tmp26_ = values;
#line 203 "../src/io/contacts-io-vcard-parser.vala"
	_tmp27_ = g_list_nth_data (_tmp26_, (guint) 5);
#line 203 "../src/io/contacts-io-vcard-parser.vala"
	_tmp25_ = (const gchar*) _tmp27_;
#line 203 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp25_ == NULL) {
#line 203 "../src/io/contacts-io-vcard-parser.vala"
		_tmp25_ = "";
#line 1445 "contacts-io-vcard-parser.c"
	}
#line 203 "../src/io/contacts-io-vcard-parser.vala"
	_tmp28_ = address;
#line 203 "../src/io/contacts-io-vcard-parser.vala"
	folks_postal_address_set_postal_code (_tmp28_, _tmp25_);
#line 204 "../src/io/contacts-io-vcard-parser.vala"
	_tmp30_ = values;
#line 204 "../src/io/contacts-io-vcard-parser.vala"
	_tmp31_ = g_list_nth_data (_tmp30_, (guint) 6);
#line 204 "../src/io/contacts-io-vcard-parser.vala"
	_tmp29_ = (const gchar*) _tmp31_;
#line 204 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp29_ == NULL) {
#line 204 "../src/io/contacts-io-vcard-parser.vala"
		_tmp29_ = "";
#line 1461 "contacts-io-vcard-parser.c"
	}
#line 204 "../src/io/contacts-io-vcard-parser.vala"
	_tmp32_ = address;
#line 204 "../src/io/contacts-io-vcard-parser.vala"
	folks_postal_address_set_country (_tmp32_, _tmp29_);
#line 206 "../src/io/contacts-io-vcard-parser.vala"
	_tmp33_ = child;
#line 206 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_add_params (self, _tmp33_, attr);
#line 187 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (child);
#line 1473 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_url (ContactsIoVCardParser* self,
                                     ContactsContact* contact,
                                     EVCardAttribute* attr)
{
	gchar* url = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	ContactsBinChunkChild* child = NULL;
	ContactsBinChunkChild* _tmp4_;
	ContactsBinChunkChild* _tmp5_;
	const gchar* _tmp6_;
	ContactsBinChunkChild* _tmp7_;
#line 209 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 209 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 210 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 210 "../src/io/contacts-io-vcard-parser.vala"
	url = _tmp0_;
#line 211 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = url;
#line 211 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp2_ == NULL) {
#line 211 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = TRUE;
#line 1506 "contacts-io-vcard-parser.c"
	} else {
		const gchar* _tmp3_;
#line 211 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = url;
#line 211 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
#line 1513 "contacts-io-vcard-parser.c"
	}
#line 211 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp1_) {
#line 212 "../src/io/contacts-io-vcard-parser.vala"
		_g_free0 (url);
#line 212 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1521 "contacts-io-vcard-parser.c"
	}
#line 214 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = contacts_io_vcard_parser_add_chunk_child_for_property (self, contact, "urls");
#line 214 "../src/io/contacts-io-vcard-parser.vala"
	child = _tmp4_;
#line 215 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = child;
#line 215 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = url;
#line 215 "../src/io/contacts-io-vcard-parser.vala"
	contacts_url_set_raw_url (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, CONTACTS_TYPE_URL, ContactsUrl), _tmp6_);
#line 216 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = child;
#line 216 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_add_params (self, _tmp7_, attr);
#line 209 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (child);
#line 209 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (url);
#line 1541 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_title (ContactsIoVCardParser* self,
                                       ContactsContact* contact,
                                       EVCardAttribute* attr)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	ContactsBinChunk* chunk = NULL;
	ContactsChunk* _tmp4_;
	ContactsBinChunk* _tmp5_;
	ContactsBinChunk* _tmp6_;
	ContactsBinChunkChild* child = NULL;
	ContactsBinChunkChild* _tmp18_;
	ContactsBinChunkChild* _tmp19_;
	FolksRole* _tmp20_;
	FolksRole* _tmp21_;
	const gchar* _tmp22_;
	ContactsBinChunkChild* _tmp23_;
#line 219 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 219 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 220 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 220 "../src/io/contacts-io-vcard-parser.vala"
	title = _tmp0_;
#line 221 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = title;
#line 221 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp2_ == NULL) {
#line 221 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = TRUE;
#line 1580 "contacts-io-vcard-parser.c"
	} else {
		const gchar* _tmp3_;
#line 221 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = title;
#line 221 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
#line 1587 "contacts-io-vcard-parser.c"
	}
#line 221 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp1_) {
#line 222 "../src/io/contacts-io-vcard-parser.vala"
		_g_free0 (title);
#line 222 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1595 "contacts-io-vcard-parser.c"
	}
#line 227 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = contacts_contact_get_most_relevant_chunk (contact, "roles", TRUE);
#line 227 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, CONTACTS_TYPE_BIN_CHUNK, ContactsBinChunk));
#line 227 "../src/io/contacts-io-vcard-parser.vala"
	chunk = _tmp5_;
#line 228 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = chunk;
#line 228 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp6_ != NULL) {
#line 1607 "contacts-io-vcard-parser.c"
		ContactsOrgRole* orgrole = NULL;
		ContactsBinChunk* _tmp7_;
		GObject* _tmp8_;
		ContactsOrgRole* _tmp9_;
		FolksRole* _tmp10_;
		FolksRole* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 229 "../src/io/contacts-io-vcard-parser.vala"
		_tmp7_ = chunk;
#line 229 "../src/io/contacts-io-vcard-parser.vala"
		_tmp8_ = g_list_model_get_item ((GListModel*) _tmp7_, (guint) 0);
#line 229 "../src/io/contacts-io-vcard-parser.vala"
		orgrole = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, CONTACTS_TYPE_ORG_ROLE, ContactsOrgRole);
#line 230 "../src/io/contacts-io-vcard-parser.vala"
		_tmp9_ = orgrole;
#line 230 "../src/io/contacts-io-vcard-parser.vala"
		_tmp10_ = contacts_org_role_get_role (_tmp9_);
#line 230 "../src/io/contacts-io-vcard-parser.vala"
		_tmp11_ = _tmp10_;
#line 230 "../src/io/contacts-io-vcard-parser.vala"
		_tmp12_ = folks_role_get_title (_tmp11_);
#line 230 "../src/io/contacts-io-vcard-parser.vala"
		_tmp13_ = _tmp12_;
#line 230 "../src/io/contacts-io-vcard-parser.vala"
		if (g_strcmp0 (_tmp13_, "") == 0) {
#line 1634 "contacts-io-vcard-parser.c"
			ContactsOrgRole* _tmp14_;
			FolksRole* _tmp15_;
			FolksRole* _tmp16_;
			const gchar* _tmp17_;
#line 231 "../src/io/contacts-io-vcard-parser.vala"
			_tmp14_ = orgrole;
#line 231 "../src/io/contacts-io-vcard-parser.vala"
			_tmp15_ = contacts_org_role_get_role (_tmp14_);
#line 231 "../src/io/contacts-io-vcard-parser.vala"
			_tmp16_ = _tmp15_;
#line 231 "../src/io/contacts-io-vcard-parser.vala"
			_tmp17_ = title;
#line 231 "../src/io/contacts-io-vcard-parser.vala"
			folks_role_set_title (_tmp16_, _tmp17_);
#line 1649 "contacts-io-vcard-parser.c"
		}
#line 232 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (orgrole);
#line 232 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (chunk);
#line 232 "../src/io/contacts-io-vcard-parser.vala"
		_g_free0 (title);
#line 232 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1659 "contacts-io-vcard-parser.c"
	}
#line 235 "../src/io/contacts-io-vcard-parser.vala"
	_tmp18_ = contacts_io_vcard_parser_add_chunk_child_for_property (self, contact, "roles");
#line 235 "../src/io/contacts-io-vcard-parser.vala"
	child = _tmp18_;
#line 236 "../src/io/contacts-io-vcard-parser.vala"
	_tmp19_ = child;
#line 236 "../src/io/contacts-io-vcard-parser.vala"
	_tmp20_ = contacts_org_role_get_role (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, CONTACTS_TYPE_ORG_ROLE, ContactsOrgRole));
#line 236 "../src/io/contacts-io-vcard-parser.vala"
	_tmp21_ = _tmp20_;
#line 236 "../src/io/contacts-io-vcard-parser.vala"
	_tmp22_ = title;
#line 236 "../src/io/contacts-io-vcard-parser.vala"
	folks_role_set_title (_tmp21_, _tmp22_);
#line 237 "../src/io/contacts-io-vcard-parser.vala"
	_tmp23_ = child;
#line 237 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_add_params (self, _tmp23_, attr);
#line 219 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (child);
#line 219 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (chunk);
#line 219 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (title);
#line 1685 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_org (ContactsIoVCardParser* self,
                                     ContactsContact* contact,
                                     EVCardAttribute* attr)
{
	GList* values = NULL;
	GList* _tmp0_;
	const gchar* org = NULL;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	ContactsBinChunk* chunk = NULL;
	ContactsChunk* _tmp6_;
	ContactsBinChunk* _tmp7_;
	ContactsBinChunk* _tmp8_;
	ContactsBinChunkChild* child = NULL;
	ContactsBinChunkChild* _tmp20_;
	ContactsBinChunkChild* _tmp21_;
	FolksRole* _tmp22_;
	FolksRole* _tmp23_;
	const gchar* _tmp24_;
	ContactsBinChunkChild* _tmp25_;
#line 240 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 240 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 241 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_values (attr);
#line 241 "../src/io/contacts-io-vcard-parser.vala"
	values = _tmp0_;
#line 242 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = values;
#line 242 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = _tmp1_->data;
#line 242 "../src/io/contacts-io-vcard-parser.vala"
	org = (const gchar*) _tmp2_;
#line 243 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = org;
#line 243 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp4_ == NULL) {
#line 243 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = TRUE;
#line 1733 "contacts-io-vcard-parser.c"
	} else {
		const gchar* _tmp5_;
#line 243 "../src/io/contacts-io-vcard-parser.vala"
		_tmp5_ = org;
#line 243 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
#line 1740 "contacts-io-vcard-parser.c"
	}
#line 243 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp3_) {
#line 244 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1746 "contacts-io-vcard-parser.c"
	}
#line 249 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = contacts_contact_get_most_relevant_chunk (contact, "roles", TRUE);
#line 249 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, CONTACTS_TYPE_BIN_CHUNK, ContactsBinChunk));
#line 249 "../src/io/contacts-io-vcard-parser.vala"
	chunk = _tmp7_;
#line 250 "../src/io/contacts-io-vcard-parser.vala"
	_tmp8_ = chunk;
#line 250 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp8_ != NULL) {
#line 1758 "contacts-io-vcard-parser.c"
		ContactsOrgRole* orgrole = NULL;
		ContactsBinChunk* _tmp9_;
		GObject* _tmp10_;
		ContactsOrgRole* _tmp11_;
		FolksRole* _tmp12_;
		FolksRole* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 251 "../src/io/contacts-io-vcard-parser.vala"
		_tmp9_ = chunk;
#line 251 "../src/io/contacts-io-vcard-parser.vala"
		_tmp10_ = g_list_model_get_item ((GListModel*) _tmp9_, (guint) 0);
#line 251 "../src/io/contacts-io-vcard-parser.vala"
		orgrole = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, CONTACTS_TYPE_ORG_ROLE, ContactsOrgRole);
#line 252 "../src/io/contacts-io-vcard-parser.vala"
		_tmp11_ = orgrole;
#line 252 "../src/io/contacts-io-vcard-parser.vala"
		_tmp12_ = contacts_org_role_get_role (_tmp11_);
#line 252 "../src/io/contacts-io-vcard-parser.vala"
		_tmp13_ = _tmp12_;
#line 252 "../src/io/contacts-io-vcard-parser.vala"
		_tmp14_ = folks_role_get_organisation_name (_tmp13_);
#line 252 "../src/io/contacts-io-vcard-parser.vala"
		_tmp15_ = _tmp14_;
#line 252 "../src/io/contacts-io-vcard-parser.vala"
		if (g_strcmp0 (_tmp15_, "") == 0) {
#line 1785 "contacts-io-vcard-parser.c"
			ContactsOrgRole* _tmp16_;
			FolksRole* _tmp17_;
			FolksRole* _tmp18_;
			const gchar* _tmp19_;
#line 253 "../src/io/contacts-io-vcard-parser.vala"
			_tmp16_ = orgrole;
#line 253 "../src/io/contacts-io-vcard-parser.vala"
			_tmp17_ = contacts_org_role_get_role (_tmp16_);
#line 253 "../src/io/contacts-io-vcard-parser.vala"
			_tmp18_ = _tmp17_;
#line 253 "../src/io/contacts-io-vcard-parser.vala"
			_tmp19_ = org;
#line 253 "../src/io/contacts-io-vcard-parser.vala"
			folks_role_set_organisation_name (_tmp18_, _tmp19_);
#line 1800 "contacts-io-vcard-parser.c"
		}
#line 254 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (orgrole);
#line 254 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (chunk);
#line 254 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1808 "contacts-io-vcard-parser.c"
	}
#line 257 "../src/io/contacts-io-vcard-parser.vala"
	_tmp20_ = contacts_io_vcard_parser_add_chunk_child_for_property (self, contact, "roles");
#line 257 "../src/io/contacts-io-vcard-parser.vala"
	child = _tmp20_;
#line 258 "../src/io/contacts-io-vcard-parser.vala"
	_tmp21_ = child;
#line 258 "../src/io/contacts-io-vcard-parser.vala"
	_tmp22_ = contacts_org_role_get_role (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, CONTACTS_TYPE_ORG_ROLE, ContactsOrgRole));
#line 258 "../src/io/contacts-io-vcard-parser.vala"
	_tmp23_ = _tmp22_;
#line 258 "../src/io/contacts-io-vcard-parser.vala"
	_tmp24_ = org;
#line 258 "../src/io/contacts-io-vcard-parser.vala"
	folks_role_set_organisation_name (_tmp23_, _tmp24_);
#line 259 "../src/io/contacts-io-vcard-parser.vala"
	_tmp25_ = child;
#line 259 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_add_params (self, _tmp25_, attr);
#line 240 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (child);
#line 240 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (chunk);
#line 1832 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_handle_note (ContactsIoVCardParser* self,
                                      ContactsContact* contact,
                                      EVCardAttribute* attr)
{
	gchar* note = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	ContactsBinChunkChild* child = NULL;
	ContactsBinChunkChild* _tmp4_;
	ContactsBinChunkChild* _tmp5_;
	const gchar* _tmp6_;
	ContactsBinChunkChild* _tmp7_;
#line 262 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (contact != NULL);
#line 262 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 263 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_value (attr);
#line 263 "../src/io/contacts-io-vcard-parser.vala"
	note = _tmp0_;
#line 264 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = note;
#line 264 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp2_ == NULL) {
#line 264 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = TRUE;
#line 1865 "contacts-io-vcard-parser.c"
	} else {
		const gchar* _tmp3_;
#line 264 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = note;
#line 264 "../src/io/contacts-io-vcard-parser.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
#line 1872 "contacts-io-vcard-parser.c"
	}
#line 264 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp1_) {
#line 265 "../src/io/contacts-io-vcard-parser.vala"
		_g_free0 (note);
#line 265 "../src/io/contacts-io-vcard-parser.vala"
		return;
#line 1880 "contacts-io-vcard-parser.c"
	}
#line 267 "../src/io/contacts-io-vcard-parser.vala"
	_tmp4_ = contacts_io_vcard_parser_add_chunk_child_for_property (self, contact, "notes");
#line 267 "../src/io/contacts-io-vcard-parser.vala"
	child = _tmp4_;
#line 268 "../src/io/contacts-io-vcard-parser.vala"
	_tmp5_ = child;
#line 268 "../src/io/contacts-io-vcard-parser.vala"
	_tmp6_ = note;
#line 268 "../src/io/contacts-io-vcard-parser.vala"
	contacts_note_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, CONTACTS_TYPE_NOTE, ContactsNote), _tmp6_);
#line 269 "../src/io/contacts-io-vcard-parser.vala"
	_tmp7_ = child;
#line 269 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_add_params (self, _tmp7_, attr);
#line 262 "../src/io/contacts-io-vcard-parser.vala"
	_g_object_unref0 (child);
#line 262 "../src/io/contacts-io-vcard-parser.vala"
	_g_free0 (note);
#line 1900 "contacts-io-vcard-parser.c"
}

static ContactsBinChunkChild*
contacts_io_vcard_parser_add_chunk_child_for_property (ContactsIoVCardParser* self,
                                                       ContactsContact* contact,
                                                       const gchar* property_name)
{
	ContactsBinChunk* chunk = NULL;
	ContactsChunk* _tmp0_;
	ContactsBinChunk* _tmp1_;
	ContactsBinChunk* _tmp2_;
	ContactsBinChunkChild* result;
#line 273 "../src/io/contacts-io-vcard-parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 273 "../src/io/contacts-io-vcard-parser.vala"
	g_return_val_if_fail (contact != NULL, NULL);
#line 273 "../src/io/contacts-io-vcard-parser.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 275 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = contacts_contact_get_most_relevant_chunk (contact, property_name, TRUE);
#line 275 "../src/io/contacts-io-vcard-parser.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, CONTACTS_TYPE_BIN_CHUNK, ContactsBinChunk));
#line 275 "../src/io/contacts-io-vcard-parser.vala"
	chunk = _tmp1_;
#line 276 "../src/io/contacts-io-vcard-parser.vala"
	_tmp2_ = chunk;
#line 276 "../src/io/contacts-io-vcard-parser.vala"
	if (_tmp2_ == NULL) {
#line 1929 "contacts-io-vcard-parser.c"
		ContactsChunk* _tmp3_;
		ContactsBinChunk* _tmp4_;
#line 277 "../src/io/contacts-io-vcard-parser.vala"
		_tmp3_ = contacts_contact_create_chunk (contact, property_name, NULL);
#line 277 "../src/io/contacts-io-vcard-parser.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, CONTACTS_TYPE_BIN_CHUNK, ContactsBinChunk));
#line 277 "../src/io/contacts-io-vcard-parser.vala"
		_g_object_unref0 (chunk);
#line 277 "../src/io/contacts-io-vcard-parser.vala"
		chunk = _tmp4_;
#line 1940 "contacts-io-vcard-parser.c"
	}
	{
		guint i = 0U;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
		i = (guint) 0;
#line 1946 "contacts-io-vcard-parser.c"
		{
			gboolean _tmp5_ = FALSE;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
			_tmp5_ = TRUE;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
			while (TRUE) {
#line 1953 "contacts-io-vcard-parser.c"
				ContactsBinChunk* _tmp7_;
				ContactsBinChunkChild* child = NULL;
				ContactsBinChunk* _tmp8_;
				GObject* _tmp9_;
				ContactsBinChunkChild* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
				if (!_tmp5_) {
#line 1963 "contacts-io-vcard-parser.c"
					guint _tmp6_;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
					_tmp6_ = i;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
					i = _tmp6_ + 1;
#line 1969 "contacts-io-vcard-parser.c"
				}
#line 281 "../src/io/contacts-io-vcard-parser.vala"
				_tmp5_ = FALSE;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
				_tmp7_ = chunk;
#line 281 "../src/io/contacts-io-vcard-parser.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp7_))) {
#line 281 "../src/io/contacts-io-vcard-parser.vala"
					break;
#line 1979 "contacts-io-vcard-parser.c"
				}
#line 282 "../src/io/contacts-io-vcard-parser.vala"
				_tmp8_ = chunk;
#line 282 "../src/io/contacts-io-vcard-parser.vala"
				_tmp9_ = g_list_model_get_item ((GListModel*) _tmp8_, i);
#line 282 "../src/io/contacts-io-vcard-parser.vala"
				child = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, CONTACTS_TYPE_BIN_CHUNK_CHILD, ContactsBinChunkChild);
#line 283 "../src/io/contacts-io-vcard-parser.vala"
				_tmp10_ = child;
#line 283 "../src/io/contacts-io-vcard-parser.vala"
				_tmp11_ = contacts_bin_chunk_child_get_is_empty (_tmp10_);
#line 283 "../src/io/contacts-io-vcard-parser.vala"
				_tmp12_ = _tmp11_;
#line 283 "../src/io/contacts-io-vcard-parser.vala"
				if (_tmp12_) {
#line 284 "../src/io/contacts-io-vcard-parser.vala"
					result = child;
#line 284 "../src/io/contacts-io-vcard-parser.vala"
					_g_object_unref0 (chunk);
#line 284 "../src/io/contacts-io-vcard-parser.vala"
					return result;
#line 2001 "contacts-io-vcard-parser.c"
				}
#line 281 "../src/io/contacts-io-vcard-parser.vala"
				_g_object_unref0 (child);
#line 2005 "contacts-io-vcard-parser.c"
			}
		}
	}
#line 287 "../src/io/contacts-io-vcard-parser.vala"
	g_return_val_if_reached (NULL);
#line 2011 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_add_params (ContactsIoVCardParser* self,
                                     ContactsBinChunkChild* chunk_child,
                                     EVCardAttribute* attr)
{
	GList* _tmp0_;
#line 292 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (chunk_child != NULL);
#line 292 "../src/io/contacts-io-vcard-parser.vala"
	g_return_if_fail (attr != NULL);
#line 293 "../src/io/contacts-io-vcard-parser.vala"
	_tmp0_ = e_vcard_attribute_get_params (attr);
#line 2028 "contacts-io-vcard-parser.c"
	{
		GList* param_collection = NULL;
		GList* param_it = NULL;
#line 293 "../src/io/contacts-io-vcard-parser.vala"
		param_collection = _tmp0_;
#line 293 "../src/io/contacts-io-vcard-parser.vala"
		for (param_it = param_collection; param_it != NULL; param_it = param_it->next) {
#line 2036 "contacts-io-vcard-parser.c"
			EVCardAttributeParam* param = NULL;
#line 293 "../src/io/contacts-io-vcard-parser.vala"
			param = (EVCardAttributeParam*) param_it->data;
#line 2040 "contacts-io-vcard-parser.c"
			{
				gchar* param_name = NULL;
				EVCardAttributeParam* _tmp1_;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				EVCardAttributeParam* _tmp4_;
				GList* _tmp5_;
#line 294 "../src/io/contacts-io-vcard-parser.vala"
				_tmp1_ = param;
#line 294 "../src/io/contacts-io-vcard-parser.vala"
				_tmp2_ = e_vcard_attribute_param_get_name (_tmp1_);
#line 294 "../src/io/contacts-io-vcard-parser.vala"
				_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 294 "../src/io/contacts-io-vcard-parser.vala"
				param_name = _tmp3_;
#line 295 "../src/io/contacts-io-vcard-parser.vala"
				_tmp4_ = param;
#line 295 "../src/io/contacts-io-vcard-parser.vala"
				_tmp5_ = e_vcard_attribute_param_get_values (_tmp4_);
#line 2060 "contacts-io-vcard-parser.c"
				{
					GList* param_value_collection = NULL;
					GList* param_value_it = NULL;
#line 295 "../src/io/contacts-io-vcard-parser.vala"
					param_value_collection = _tmp5_;
#line 295 "../src/io/contacts-io-vcard-parser.vala"
					for (param_value_it = param_value_collection; param_value_it != NULL; param_value_it = param_value_it->next) {
#line 2068 "contacts-io-vcard-parser.c"
						const gchar* param_value = NULL;
#line 295 "../src/io/contacts-io-vcard-parser.vala"
						param_value = (const gchar*) param_value_it->data;
#line 2072 "contacts-io-vcard-parser.c"
						{
							const gchar* _tmp6_;
#line 296 "../src/io/contacts-io-vcard-parser.vala"
							_tmp6_ = param_name;
#line 296 "../src/io/contacts-io-vcard-parser.vala"
							if (g_strcmp0 (_tmp6_, "type") == 0) {
#line 2079 "contacts-io-vcard-parser.c"
								const gchar* _tmp7_;
								const gchar* _tmp8_;
								gchar* _tmp9_;
								gchar* _tmp10_;
#line 297 "../src/io/contacts-io-vcard-parser.vala"
								_tmp7_ = param_name;
#line 297 "../src/io/contacts-io-vcard-parser.vala"
								_tmp8_ = param_value;
#line 297 "../src/io/contacts-io-vcard-parser.vala"
								_tmp9_ = g_utf8_strdown (_tmp8_, (gssize) -1);
#line 297 "../src/io/contacts-io-vcard-parser.vala"
								_tmp10_ = _tmp9_;
#line 297 "../src/io/contacts-io-vcard-parser.vala"
								contacts_bin_chunk_child_add_parameter (chunk_child, _tmp7_, _tmp10_);
#line 297 "../src/io/contacts-io-vcard-parser.vala"
								_g_free0 (_tmp10_);
#line 2096 "contacts-io-vcard-parser.c"
							} else {
								const gchar* _tmp11_;
								const gchar* _tmp12_;
#line 299 "../src/io/contacts-io-vcard-parser.vala"
								_tmp11_ = param_name;
#line 299 "../src/io/contacts-io-vcard-parser.vala"
								_tmp12_ = param_value;
#line 299 "../src/io/contacts-io-vcard-parser.vala"
								contacts_bin_chunk_child_add_parameter (chunk_child, _tmp11_, _tmp12_);
#line 2106 "contacts-io-vcard-parser.c"
							}
						}
					}
				}
#line 293 "../src/io/contacts-io-vcard-parser.vala"
				_g_free0 (param_name);
#line 2113 "contacts-io-vcard-parser.c"
			}
		}
	}
}

static void
contacts_io_vcard_parser_class_init (ContactsIoVCardParserClass * klass,
                                     gpointer klass_data)
{
#line 23 "../src/io/contacts-io-vcard-parser.vala"
	contacts_io_vcard_parser_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/io/contacts-io-vcard-parser.vala"
	((ContactsIoParserClass *) klass)->parse = (ContactsContact** (*) (ContactsIoParser*, GInputStream*, gint*, GError**)) contacts_io_vcard_parser_real_parse;
#line 2127 "contacts-io-vcard-parser.c"
}

static void
contacts_io_vcard_parser_instance_init (ContactsIoVCardParser * self,
                                        gpointer klass)
{
}

/**
 * A {@link Contacts.Io.Parser} that specifically deals with parsing VCard
 */
 G_GNUC_NO_INLINE static GType
contacts_io_vcard_parser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsIoVCardParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_io_vcard_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsIoVCardParser), 0, (GInstanceInitFunc) contacts_io_vcard_parser_instance_init, NULL };
	GType contacts_io_vcard_parser_type_id;
	contacts_io_vcard_parser_type_id = g_type_register_static (CONTACTS_IO_TYPE_PARSER, "ContactsIoVCardParser", &g_define_type_info, 0);
	return contacts_io_vcard_parser_type_id;
}

GType
contacts_io_vcard_parser_get_type (void)
{
	static volatile gsize contacts_io_vcard_parser_type_id__once = 0;
	if (g_once_init_enter (&contacts_io_vcard_parser_type_id__once)) {
		GType contacts_io_vcard_parser_type_id;
		contacts_io_vcard_parser_type_id = contacts_io_vcard_parser_get_type_once ();
		g_once_init_leave (&contacts_io_vcard_parser_type_id__once, contacts_io_vcard_parser_type_id);
	}
	return contacts_io_vcard_parser_type_id__once;
}

