/* contacts-io-vcard-export-operation.c generated by valac 0.56.4, the Vala compiler
 * generated from contacts-io-vcard-export-operation.vala, do not modify */

/*
 * Copyright (C) 2022 Niels De Graef <nielsdegraef@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "contacts.h"
#include <libebook-contacts/libebook-contacts.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <folks/folks.h>
#include <glib/gi18n-lib.h>
#include <folks/folks-eds.h>

enum  {
	CONTACTS_IO_VCARD_EXPORT_OPERATION_0_PROPERTY,
	CONTACTS_IO_VCARD_EXPORT_OPERATION_DESCRIPTION_PROPERTY,
	CONTACTS_IO_VCARD_EXPORT_OPERATION_NUM_PROPERTIES
};
static GParamSpec* contacts_io_vcard_export_operation_properties[CONTACTS_IO_VCARD_EXPORT_OPERATION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ContactsIoVcardExportOperationExecuteData ContactsIoVcardExportOperationExecuteData;
#define __vala_EVCardAttribute_free0(var) ((var == NULL) ? NULL : (var = (_vala_EVCardAttribute_free (var), NULL)))
#define __vala_EVCardAttributeParam_free0(var) ((var == NULL) ? NULL : (var = (_vala_EVCardAttributeParam_free (var), NULL)))

struct _ContactsIoVCardExportOperationPrivate {
	EVCardFormat vcard_format;
	gboolean avoid_eds;
	gchar* _description;
};

struct _ContactsIoVcardExportOperationExecuteData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsIoVCardExportOperation* self;
	GeeList* _individual_list;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	gint _individual_size;
	GeeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _individual_index;
	gint _tmp5_;
	gint _tmp6_;
	FolksIndividual* individual;
	GeeList* _tmp7_;
	gpointer _tmp8_;
	GeeIterator* _persona_it;
	FolksIndividual* _tmp9_;
	GeeSet* _tmp10_;
	GeeSet* _tmp11_;
	GeeIterator* _tmp12_;
	GeeIterator* _tmp13_;
	FolksPersona* persona;
	GeeIterator* _tmp14_;
	gpointer _tmp15_;
	gchar* vcard_str;
	FolksPersona* _tmp16_;
	gchar* _tmp17_;
	gsize written;
	GOutputStream* _tmp18_;
	GOutputStream* _tmp19_;
	const gchar* _tmp20_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gint _tmp22_;
	guint8* _tmp23_;
	gint _tmp23__length1;
	gsize _tmp24_;
	GOutputStream* _tmp25_;
	GOutputStream* _tmp26_;
	guint8* _tmp27_;
	gint _tmp27__length1;
	gint _tmp28_;
	guint8* _tmp29_;
	gint _tmp29__length1;
	gsize _tmp30_;
	GError* _inner_error0_;
};

static gint ContactsIoVCardExportOperation_private_offset;
static gpointer contacts_io_vcard_export_operation_parent_class = NULL;

static void contacts_io_vcard_export_operation_real_execute_data_free (gpointer _data);
static void contacts_io_vcard_export_operation_real_execute (ContactsOperation* base,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static gboolean contacts_io_vcard_export_operation_real_execute_co (ContactsIoVcardExportOperationExecuteData* _data_);
static gchar* contacts_io_vcard_export_operation_persona_to_vcard (ContactsIoVCardExportOperation* self,
                                                            FolksPersona* persona);
static void contacts_io_vcard_export_operation_vcard_set_avatar_details (ContactsIoVCardExportOperation* self,
                                                                  EVCard* vcard,
                                                                  FolksAvatarDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_birthday_details (ContactsIoVCardExportOperation* self,
                                                                    EVCard* vcard,
                                                                    FolksBirthdayDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_email_details (ContactsIoVCardExportOperation* self,
                                                                 EVCard* vcard,
                                                                 FolksEmailDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_favourite_details (ContactsIoVCardExportOperation* self,
                                                                     EVCard* vcard,
                                                                     FolksFavouriteDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_name_details (ContactsIoVCardExportOperation* self,
                                                                EVCard* vcard,
                                                                FolksNameDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_note_details (ContactsIoVCardExportOperation* self,
                                                                EVCard* vcard,
                                                                FolksNoteDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_phone_details (ContactsIoVCardExportOperation* self,
                                                                 EVCard* vcard,
                                                                 FolksPhoneDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_postal_address_details (ContactsIoVCardExportOperation* self,
                                                                          EVCard* vcard,
                                                                          FolksPostalAddressDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_role_details (ContactsIoVCardExportOperation* self,
                                                                EVCard* vcard,
                                                                FolksRoleDetails* details);
static void contacts_io_vcard_export_operation_vcard_set_url_details (ContactsIoVCardExportOperation* self,
                                                               EVCard* vcard,
                                                               FolksUrlDetails* details);
static void _vala_EVCardAttribute_free (EVCardAttribute* self);
static EVCardAttribute* _vala_EVCardAttribute_copy (EVCardAttribute* self);
static void contacts_io_vcard_export_operation_add_parameters_for_field_details (ContactsIoVCardExportOperation* self,
                                                                          EVCardAttribute* attr,
                                                                          FolksAbstractFieldDetails* field);
static void _vala_EVCardAttributeParam_free (EVCardAttributeParam* self);
static void contacts_io_vcard_export_operation_finalize (GObject * obj);
static GType contacts_io_vcard_export_operation_get_type_once (void);
static void _vala_contacts_io_vcard_export_operation_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);

static inline gpointer
contacts_io_vcard_export_operation_get_instance_private (ContactsIoVCardExportOperation* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsIoVCardExportOperation_private_offset);
}

ContactsIoVCardExportOperation*
contacts_io_vcard_export_operation_construct (GType object_type,
                                              GeeList* individuals,
                                              GOutputStream* output)
{
	ContactsIoVCardExportOperation * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
#line 40 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_val_if_fail (individuals != NULL, NULL);
#line 40 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_val_if_fail (output != NULL, NULL);
#line 42 "../src/io/contacts-io-vcard-export-operation.vala"
	self = (ContactsIoVCardExportOperation*) g_object_new (object_type, "individuals", individuals, "output", output, NULL);
#line 44 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) individuals);
#line 44 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp1_ = _tmp0_;
#line 44 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) individuals);
#line 44 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp3_ = _tmp2_;
#line 44 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp4_ = g_strdup_printf (ngettext ("Exported %d contact", "Exported %d contacts", (gulong) _tmp1_), _tmp3_);
#line 44 "../src/io/contacts-io-vcard-export-operation.vala"
	_g_free0 (self->priv->_description);
#line 44 "../src/io/contacts-io-vcard-export-operation.vala"
	self->priv->_description = _tmp4_;
#line 40 "../src/io/contacts-io-vcard-export-operation.vala"
	return self;
#line 196 "contacts-io-vcard-export-operation.c"
}

ContactsIoVCardExportOperation*
contacts_io_vcard_export_operation_new (GeeList* individuals,
                                        GOutputStream* output)
{
#line 40 "../src/io/contacts-io-vcard-export-operation.vala"
	return contacts_io_vcard_export_operation_construct (CONTACTS_IO_TYPE_VCARD_EXPORT_OPERATION, individuals, output);
#line 205 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_real_execute_data_free (gpointer _data)
{
	ContactsIoVcardExportOperationExecuteData* _data_;
	_data_ = _data;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	g_slice_free (ContactsIoVcardExportOperationExecuteData, _data_);
#line 217 "contacts-io-vcard-export-operation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	return self ? g_object_ref (self) : NULL;
#line 225 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_real_execute (ContactsOperation* base,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	ContactsIoVCardExportOperation * self;
	ContactsIoVcardExportOperationExecuteData* _data_;
	ContactsIoVCardExportOperation* _tmp0_;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	self = (ContactsIoVCardExportOperation*) base;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	_data_ = g_slice_new0 (ContactsIoVcardExportOperationExecuteData);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contacts_io_vcard_export_operation_real_execute_data_free);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	_data_->self = _tmp0_;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	contacts_io_vcard_export_operation_real_execute_co (_data_);
#line 250 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_execute_finish (ContactsOperation* base,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	ContactsIoVcardExportOperationExecuteData* _data_;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	if (NULL == _data_) {
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
		return;
#line 265 "contacts-io-vcard-export-operation.c"
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1563 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1564 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1564 "glib-2.0.vapi"
	res_length1 = -1;
#line 1564 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1565 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1565 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1565 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1566 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1566 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1566 "glib-2.0.vapi"
	if (result_length1) {
#line 1566 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 303 "contacts-io-vcard-export-operation.c"
	}
#line 1566 "glib-2.0.vapi"
	result = _tmp2_;
#line 1566 "glib-2.0.vapi"
	return result;
#line 309 "contacts-io-vcard-export-operation.c"
}

static gboolean
contacts_io_vcard_export_operation_real_execute_co (ContactsIoVcardExportOperationExecuteData* _data_)
{
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
	switch (_data_->_state_) {
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
		case 0:
#line 319 "contacts-io-vcard-export-operation.c"
		goto _state_0;
		default:
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
		g_assert_not_reached ();
#line 324 "contacts-io-vcard-export-operation.c"
	}
	_state_0:
	{
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_tmp0_ = contacts_io_export_operation_get_individuals ((ContactsIoExportOperation*) _data_->self);
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_tmp1_ = _data_->_tmp0_;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_individual_list = _data_->_tmp1_;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_tmp2_ = _data_->_individual_list;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_tmp3_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp2_);
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_individual_size = _data_->_tmp4_;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		_data_->_individual_index = -1;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
		while (TRUE) {
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			_data_->_individual_index = _data_->_individual_index + 1;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			_data_->_tmp5_ = _data_->_individual_index;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			_data_->_tmp6_ = _data_->_individual_size;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			if (!(_data_->_tmp5_ < _data_->_tmp6_)) {
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
				break;
#line 356 "contacts-io-vcard-export-operation.c"
			}
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			_data_->_tmp7_ = _data_->_individual_list;
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			_data_->_tmp8_ = gee_list_get (_data_->_tmp7_, _data_->_individual_index);
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			_data_->individual = (FolksIndividual*) _data_->_tmp8_;
#line 364 "contacts-io-vcard-export-operation.c"
			{
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
				_data_->_tmp9_ = _data_->individual;
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
				_data_->_tmp10_ = folks_individual_get_personas (_data_->_tmp9_);
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
				_data_->_tmp11_ = _data_->_tmp10_;
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
				_data_->_tmp12_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp11_);
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
				_data_->_persona_it = _data_->_tmp12_;
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
				while (TRUE) {
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp13_ = _data_->_persona_it;
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
					if (!gee_iterator_next (_data_->_tmp13_)) {
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
						break;
#line 384 "contacts-io-vcard-export-operation.c"
					}
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp14_ = _data_->_persona_it;
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp15_ = gee_iterator_get (_data_->_tmp14_);
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->persona = (FolksPersona*) _data_->_tmp15_;
#line 54 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp16_ = _data_->persona;
#line 54 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp17_ = contacts_io_vcard_export_operation_persona_to_vcard (_data_->self, _data_->_tmp16_);
#line 54 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->vcard_str = _data_->_tmp17_;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp18_ = contacts_io_export_operation_get_output ((ContactsIoExportOperation*) _data_->self);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp20_ = _data_->vcard_str;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp22_ = 0;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp21_ = string_get_data (_data_->_tmp20_, &_data_->_tmp22_);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp21__length1 = _data_->_tmp22_;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp23_ = _data_->_tmp21_;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp23__length1 = _data_->_tmp21__length1;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp24_ = 0UL;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					g_output_stream_write_all (_data_->_tmp19_, _data_->_tmp23_, (gsize) _data_->_tmp23__length1, &_data_->_tmp24_, NULL, &_data_->_inner_error0_);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->written = _data_->_tmp24_;
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_free0 (_data_->vcard_str);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_object_unref0 (_data_->persona);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_object_unref0 (_data_->_persona_it);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_object_unref0 (_data_->individual);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
						g_object_unref (_data_->_async_result);
#line 56 "../src/io/contacts-io-vcard-export-operation.vala"
						return FALSE;
#line 436 "contacts-io-vcard-export-operation.c"
					}
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp25_ = contacts_io_export_operation_get_output ((ContactsIoExportOperation*) _data_->self);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp26_ = _data_->_tmp25_;
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp28_ = 0;
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp27_ = string_get_data ("\r\n\r\n", &_data_->_tmp28_);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp27__length1 = _data_->_tmp28_;
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp29_ = _data_->_tmp27_;
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp29__length1 = _data_->_tmp27__length1;
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->_tmp30_ = 0UL;
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					g_output_stream_write_all (_data_->_tmp26_, _data_->_tmp29_, (gsize) _data_->_tmp29__length1, &_data_->_tmp30_, NULL, &_data_->_inner_error0_);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					_data_->written = _data_->_tmp30_;
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_free0 (_data_->vcard_str);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_object_unref0 (_data_->persona);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_object_unref0 (_data_->_persona_it);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
						_g_object_unref0 (_data_->individual);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
						g_object_unref (_data_->_async_result);
#line 57 "../src/io/contacts-io-vcard-export-operation.vala"
						return FALSE;
#line 474 "contacts-io-vcard-export-operation.c"
					}
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
					_g_free0 (_data_->vcard_str);
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
					_g_object_unref0 (_data_->persona);
#line 480 "contacts-io-vcard-export-operation.c"
				}
#line 53 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_object_unref0 (_data_->_persona_it);
#line 484 "contacts-io-vcard-export-operation.c"
			}
#line 50 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (_data_->individual);
#line 488 "contacts-io-vcard-export-operation.c"
		}
	}
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
	if (_data_->_state_ != 0) {
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 499 "contacts-io-vcard-export-operation.c"
		}
	}
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
	g_object_unref (_data_->_async_result);
#line 49 "../src/io/contacts-io-vcard-export-operation.vala"
	return FALSE;
#line 506 "contacts-io-vcard-export-operation.c"
}

static gchar*
contacts_io_vcard_export_operation_persona_to_vcard (ContactsIoVCardExportOperation* self,
                                                     FolksPersona* persona)
{
	gboolean _tmp0_ = FALSE;
	EVCard* vcard = NULL;
	EVCard* _tmp5_;
	EVCard* _tmp16_;
	gchar* _tmp17_;
	gchar* result;
#line 62 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_val_if_fail (persona != NULL, NULL);
#line 65 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, EDSF_TYPE_PERSONA)) {
#line 65 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = !self->priv->avoid_eds;
#line 527 "contacts-io-vcard-export-operation.c"
	} else {
#line 65 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = FALSE;
#line 531 "contacts-io-vcard-export-operation.c"
	}
#line 65 "../src/io/contacts-io-vcard-export-operation.vala"
	if (_tmp0_) {
#line 535 "contacts-io-vcard-export-operation.c"
		EContact* contact = NULL;
		EContact* _tmp1_;
		EContact* _tmp2_;
		EContact* _tmp3_;
		gchar* _tmp4_;
#line 66 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = edsf_persona_get_contact (G_TYPE_CHECK_INSTANCE_CAST (persona, EDSF_TYPE_PERSONA, EdsfPersona));
#line 66 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = _tmp1_;
#line 66 "../src/io/contacts-io-vcard-export-operation.vala"
		contact = _tmp2_;
#line 67 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp3_ = contact;
#line 67 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp4_ = e_vcard_to_string ((EVCard*) _tmp3_, self->priv->vcard_format);
#line 67 "../src/io/contacts-io-vcard-export-operation.vala"
		result = _tmp4_;
#line 67 "../src/io/contacts-io-vcard-export-operation.vala"
		return result;
#line 555 "contacts-io-vcard-export-operation.c"
	}
#line 70 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp5_ = e_vcard_new ();
#line 70 "../src/io/contacts-io-vcard-export-operation.vala"
	vcard = _tmp5_;
#line 72 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_AVATAR_DETAILS)) {
#line 563 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp6_;
#line 73 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp6_ = vcard;
#line 73 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_avatar_details (self, _tmp6_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_AVATAR_DETAILS, FolksAvatarDetails));
#line 569 "contacts-io-vcard-export-operation.c"
	}
#line 74 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_BIRTHDAY_DETAILS)) {
#line 573 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp7_;
#line 75 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp7_ = vcard;
#line 75 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_birthday_details (self, _tmp7_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_BIRTHDAY_DETAILS, FolksBirthdayDetails));
#line 579 "contacts-io-vcard-export-operation.c"
	}
#line 76 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_EMAIL_DETAILS)) {
#line 583 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp8_;
#line 77 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp8_ = vcard;
#line 77 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_email_details (self, _tmp8_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_EMAIL_DETAILS, FolksEmailDetails));
#line 589 "contacts-io-vcard-export-operation.c"
	}
#line 78 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_FAVOURITE_DETAILS)) {
#line 593 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp9_;
#line 79 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp9_ = vcard;
#line 79 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_favourite_details (self, _tmp9_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_FAVOURITE_DETAILS, FolksFavouriteDetails));
#line 599 "contacts-io-vcard-export-operation.c"
	}
#line 80 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_NAME_DETAILS)) {
#line 603 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp10_;
#line 81 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp10_ = vcard;
#line 81 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_name_details (self, _tmp10_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_NAME_DETAILS, FolksNameDetails));
#line 609 "contacts-io-vcard-export-operation.c"
	}
#line 82 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_NOTE_DETAILS)) {
#line 613 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp11_;
#line 83 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp11_ = vcard;
#line 83 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_note_details (self, _tmp11_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_NOTE_DETAILS, FolksNoteDetails));
#line 619 "contacts-io-vcard-export-operation.c"
	}
#line 84 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_PHONE_DETAILS)) {
#line 623 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp12_;
#line 85 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp12_ = vcard;
#line 85 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_phone_details (self, _tmp12_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_PHONE_DETAILS, FolksPhoneDetails));
#line 629 "contacts-io-vcard-export-operation.c"
	}
#line 86 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_POSTAL_ADDRESS_DETAILS)) {
#line 633 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp13_;
#line 87 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp13_ = vcard;
#line 87 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_postal_address_details (self, _tmp13_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_POSTAL_ADDRESS_DETAILS, FolksPostalAddressDetails));
#line 639 "contacts-io-vcard-export-operation.c"
	}
#line 88 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_ROLE_DETAILS)) {
#line 643 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp14_;
#line 89 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp14_ = vcard;
#line 89 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_role_details (self, _tmp14_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_ROLE_DETAILS, FolksRoleDetails));
#line 649 "contacts-io-vcard-export-operation.c"
	}
#line 90 "../src/io/contacts-io-vcard-export-operation.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (persona, FOLKS_TYPE_URL_DETAILS)) {
#line 653 "contacts-io-vcard-export-operation.c"
		EVCard* _tmp15_;
#line 91 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp15_ = vcard;
#line 91 "../src/io/contacts-io-vcard-export-operation.vala"
		contacts_io_vcard_export_operation_vcard_set_url_details (self, _tmp15_, G_TYPE_CHECK_INSTANCE_CAST (persona, FOLKS_TYPE_URL_DETAILS, FolksUrlDetails));
#line 659 "contacts-io-vcard-export-operation.c"
	}
#line 118 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp16_ = vcard;
#line 118 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp17_ = e_vcard_to_string (_tmp16_, self->priv->vcard_format);
#line 118 "../src/io/contacts-io-vcard-export-operation.vala"
	result = _tmp17_;
#line 118 "../src/io/contacts-io-vcard-export-operation.vala"
	_g_object_unref0 (vcard);
#line 118 "../src/io/contacts-io-vcard-export-operation.vala"
	return result;
#line 671 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_vcard_set_avatar_details (ContactsIoVCardExportOperation* self,
                                                             EVCard* vcard,
                                                             FolksAvatarDetails* details)
{
#line 121 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 121 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 685 "contacts-io-vcard-export-operation.c"
}

static void
_vala_EVCardAttribute_free (EVCardAttribute* self)
{
#line 128 "../src/io/contacts-io-vcard-export-operation.vala"
	g_boxed_free (e_vcard_attribute_get_type (), self);
#line 693 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_vcard_set_birthday_details (ContactsIoVCardExportOperation* self,
                                                               EVCard* vcard,
                                                               FolksBirthdayDetails* details)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	EVCardAttribute* attr = NULL;
	EVCardAttribute* _tmp2_;
	EVCardAttribute* _tmp3_;
	EVCardAttributeParam* _tmp4_;
	EVCardAttribute* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 128 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 128 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 130 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp0_ = folks_birthday_details_get_birthday (details);
#line 130 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp1_ = _tmp0_;
#line 130 "../src/io/contacts-io-vcard-export-operation.vala"
	if (_tmp1_ == NULL) {
#line 131 "../src/io/contacts-io-vcard-export-operation.vala"
		return;
#line 726 "contacts-io-vcard-export-operation.c"
	}
#line 133 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp2_ = e_vcard_attribute_new (NULL, EVC_BDAY);
#line 133 "../src/io/contacts-io-vcard-export-operation.vala"
	attr = _tmp2_;
#line 134 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp3_ = attr;
#line 134 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp4_ = e_vcard_attribute_param_new (EVC_VALUE);
#line 134 "../src/io/contacts-io-vcard-export-operation.vala"
	e_vcard_attribute_add_param_with_value (_tmp3_, _tmp4_, "DATE");
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp5_ = attr;
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	attr = NULL;
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp6_ = folks_birthday_details_get_birthday (details);
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp7_ = _tmp6_;
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp8_ = g_date_time_format (_tmp7_, "%F");
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp9_ = _tmp8_;
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	e_vcard_add_attribute_with_value (vcard, _tmp5_, _tmp9_);
#line 135 "../src/io/contacts-io-vcard-export-operation.vala"
	_g_free0 (_tmp9_);
#line 128 "../src/io/contacts-io-vcard-export-operation.vala"
	__vala_EVCardAttribute_free0 (attr);
#line 756 "contacts-io-vcard-export-operation.c"
}

static EVCardAttribute*
_vala_EVCardAttribute_copy (EVCardAttribute* self)
{
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
	return g_boxed_copy (e_vcard_attribute_get_type (), self);
#line 764 "contacts-io-vcard-export-operation.c"
}

static gpointer
__vala_EVCardAttribute_copy0 (gpointer self)
{
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
	return self ? _vala_EVCardAttribute_copy (self) : NULL;
#line 772 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_vcard_set_email_details (ContactsIoVCardExportOperation* self,
                                                            EVCard* vcard,
                                                            FolksEmailDetails* details)
{
#line 138 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 138 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 786 "contacts-io-vcard-export-operation.c"
	{
		GeeIterator* _email_field_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = folks_email_details_get_email_addresses (details);
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = _tmp0_;
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
		_email_field_it = _tmp2_;
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
		while (TRUE) {
#line 802 "contacts-io-vcard-export-operation.c"
			GeeIterator* _tmp3_;
			FolksEmailFieldDetails* email_field = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksEmailFieldDetails* _tmp6_;
			gconstpointer _tmp7_;
			gconstpointer _tmp8_;
			EVCardAttribute* attr = NULL;
			EVCardAttribute* _tmp9_;
			EVCardAttribute* _tmp10_;
			EVCardAttribute* _tmp11_;
			FolksEmailFieldDetails* _tmp12_;
			gconstpointer _tmp13_;
			gconstpointer _tmp14_;
			EVCardAttribute* _tmp15_;
			FolksEmailFieldDetails* _tmp16_;
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp3_ = _email_field_it;
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
				break;
#line 825 "contacts-io-vcard-export-operation.c"
			}
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp4_ = _email_field_it;
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
			email_field = (FolksEmailFieldDetails*) _tmp5_;
#line 141 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp6_ = email_field;
#line 141 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp6_);
#line 141 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp8_ = _tmp7_;
#line 141 "../src/io/contacts-io-vcard-export-operation.vala"
			if (g_strcmp0 ((const gchar*) _tmp8_, "") == 0) {
#line 142 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_object_unref0 (email_field);
#line 142 "../src/io/contacts-io-vcard-export-operation.vala"
				continue;
#line 845 "contacts-io-vcard-export-operation.c"
			}
#line 144 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp9_ = e_vcard_attribute_new (NULL, EVC_EMAIL);
#line 144 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = _tmp9_;
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp10_ = attr;
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp11_ = __vala_EVCardAttribute_copy0 (_tmp10_);
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp12_ = email_field;
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp13_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp12_);
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp14_ = _tmp13_;
#line 145 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_add_attribute_with_value (vcard, _tmp11_, (const gchar*) _tmp14_);
#line 146 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp15_ = attr;
#line 146 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp16_ = email_field;
#line 146 "../src/io/contacts-io-vcard-export-operation.vala"
			contacts_io_vcard_export_operation_add_parameters_for_field_details (self, _tmp15_, (FolksAbstractFieldDetails*) _tmp16_);
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
			__vala_EVCardAttribute_free0 (attr);
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (email_field);
#line 873 "contacts-io-vcard-export-operation.c"
		}
#line 140 "../src/io/contacts-io-vcard-export-operation.vala"
		_g_object_unref0 (_email_field_it);
#line 877 "contacts-io-vcard-export-operation.c"
	}
}

static void
contacts_io_vcard_export_operation_vcard_set_favourite_details (ContactsIoVCardExportOperation* self,
                                                                EVCard* vcard,
                                                                FolksFavouriteDetails* details)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 150 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 150 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 152 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp0_ = folks_favourite_details_get_is_favourite (details);
#line 152 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp1_ = _tmp0_;
#line 152 "../src/io/contacts-io-vcard-export-operation.vala"
	if (_tmp1_) {
#line 900 "contacts-io-vcard-export-operation.c"
		EVCardAttribute* attr = NULL;
		EVCardAttribute* _tmp2_;
		EVCardAttribute* _tmp3_;
#line 154 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = e_vcard_attribute_new (NULL, "X-FOLKS-FAVOURITE");
#line 154 "../src/io/contacts-io-vcard-export-operation.vala"
		attr = _tmp2_;
#line 155 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp3_ = attr;
#line 155 "../src/io/contacts-io-vcard-export-operation.vala"
		attr = NULL;
#line 155 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_add_attribute_with_value (vcard, _tmp3_, "true");
#line 152 "../src/io/contacts-io-vcard-export-operation.vala"
		__vala_EVCardAttribute_free0 (attr);
#line 916 "contacts-io-vcard-export-operation.c"
	}
}

static void
contacts_io_vcard_export_operation_vcard_set_name_details (ContactsIoVCardExportOperation* self,
                                                           EVCard* vcard,
                                                           FolksNameDetails* details)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	FolksStructuredName* _tmp5_;
	FolksStructuredName* _tmp6_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
#line 159 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 159 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 161 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp0_ = folks_name_details_get_full_name (details);
#line 161 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp1_ = _tmp0_;
#line 161 "../src/io/contacts-io-vcard-export-operation.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 943 "contacts-io-vcard-export-operation.c"
		EVCardAttribute* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 162 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = e_vcard_attribute_new (NULL, EVC_FN);
#line 162 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp3_ = folks_name_details_get_full_name (details);
#line 162 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp4_ = _tmp3_;
#line 162 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_add_attribute_with_value (vcard, _tmp2_, _tmp4_);
#line 955 "contacts-io-vcard-export-operation.c"
	}
#line 166 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp5_ = folks_name_details_get_structured_name (details);
#line 166 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp6_ = _tmp5_;
#line 166 "../src/io/contacts-io-vcard-export-operation.vala"
	if (_tmp6_ != NULL) {
#line 963 "contacts-io-vcard-export-operation.c"
		EVCardAttribute* attr = NULL;
		EVCardAttribute* _tmp7_;
		EVCardAttribute* _tmp8_;
		FolksStructuredName* _tmp9_;
		FolksStructuredName* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		EVCardAttribute* _tmp13_;
		FolksStructuredName* _tmp14_;
		FolksStructuredName* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		EVCardAttribute* _tmp18_;
		FolksStructuredName* _tmp19_;
		FolksStructuredName* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		EVCardAttribute* _tmp23_;
		FolksStructuredName* _tmp24_;
		FolksStructuredName* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		EVCardAttribute* _tmp28_;
		FolksStructuredName* _tmp29_;
		FolksStructuredName* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		EVCardAttribute* _tmp33_;
#line 167 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp7_ = e_vcard_attribute_new (NULL, EVC_N);
#line 167 "../src/io/contacts-io-vcard-export-operation.vala"
		attr = _tmp7_;
#line 169 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp8_ = attr;
#line 169 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp9_ = folks_name_details_get_structured_name (details);
#line 169 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp10_ = _tmp9_;
#line 169 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp11_ = folks_structured_name_get_family_name (_tmp10_);
#line 169 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp12_ = _tmp11_;
#line 169 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_attribute_add_value (_tmp8_, _tmp12_);
#line 170 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp13_ = attr;
#line 170 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp14_ = folks_name_details_get_structured_name (details);
#line 170 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp15_ = _tmp14_;
#line 170 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp16_ = folks_structured_name_get_given_name (_tmp15_);
#line 170 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp17_ = _tmp16_;
#line 170 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_attribute_add_value (_tmp13_, _tmp17_);
#line 171 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp18_ = attr;
#line 171 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp19_ = folks_name_details_get_structured_name (details);
#line 171 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp20_ = _tmp19_;
#line 171 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp21_ = folks_structured_name_get_additional_names (_tmp20_);
#line 171 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp22_ = _tmp21_;
#line 171 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_attribute_add_value (_tmp18_, _tmp22_);
#line 172 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp23_ = attr;
#line 172 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp24_ = folks_name_details_get_structured_name (details);
#line 172 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp25_ = _tmp24_;
#line 172 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp26_ = folks_structured_name_get_prefixes (_tmp25_);
#line 172 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp27_ = _tmp26_;
#line 172 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_attribute_add_value (_tmp23_, _tmp27_);
#line 173 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp28_ = attr;
#line 173 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp29_ = folks_name_details_get_structured_name (details);
#line 173 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp30_ = _tmp29_;
#line 173 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp31_ = folks_structured_name_get_suffixes (_tmp30_);
#line 173 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp32_ = _tmp31_;
#line 173 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_attribute_add_value (_tmp28_, _tmp32_);
#line 175 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp33_ = attr;
#line 175 "../src/io/contacts-io-vcard-export-operation.vala"
		attr = NULL;
#line 175 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_add_attribute (vcard, _tmp33_);
#line 166 "../src/io/contacts-io-vcard-export-operation.vala"
		__vala_EVCardAttribute_free0 (attr);
#line 1064 "contacts-io-vcard-export-operation.c"
	}
#line 178 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp34_ = folks_name_details_get_nickname (details);
#line 178 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp35_ = _tmp34_;
#line 178 "../src/io/contacts-io-vcard-export-operation.vala"
	if (g_strcmp0 (_tmp35_, "") != 0) {
#line 1072 "contacts-io-vcard-export-operation.c"
		EVCardAttribute* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
#line 179 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp36_ = e_vcard_attribute_new (NULL, EVC_NICKNAME);
#line 179 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp37_ = folks_name_details_get_nickname (details);
#line 179 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp38_ = _tmp37_;
#line 179 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_add_attribute_with_value (vcard, _tmp36_, _tmp38_);
#line 1084 "contacts-io-vcard-export-operation.c"
	}
}

static void
contacts_io_vcard_export_operation_vcard_set_note_details (ContactsIoVCardExportOperation* self,
                                                           EVCard* vcard,
                                                           FolksNoteDetails* details)
{
#line 184 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 184 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 1099 "contacts-io-vcard-export-operation.c"
	{
		GeeIterator* _note_field_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = folks_note_details_get_notes (details);
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = _tmp0_;
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
		_note_field_it = _tmp2_;
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
		while (TRUE) {
#line 1115 "contacts-io-vcard-export-operation.c"
			GeeIterator* _tmp3_;
			FolksNoteFieldDetails* note_field = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksNoteFieldDetails* _tmp6_;
			gconstpointer _tmp7_;
			gconstpointer _tmp8_;
			EVCardAttribute* attr = NULL;
			EVCardAttribute* _tmp9_;
			EVCardAttribute* _tmp10_;
			FolksNoteFieldDetails* _tmp11_;
			EVCardAttribute* _tmp12_;
			FolksNoteFieldDetails* _tmp13_;
			gconstpointer _tmp14_;
			gconstpointer _tmp15_;
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp3_ = _note_field_it;
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
				break;
#line 1137 "contacts-io-vcard-export-operation.c"
			}
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp4_ = _note_field_it;
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
			note_field = (FolksNoteFieldDetails*) _tmp5_;
#line 187 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp6_ = note_field;
#line 187 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp6_);
#line 187 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp8_ = _tmp7_;
#line 187 "../src/io/contacts-io-vcard-export-operation.vala"
			if (g_strcmp0 ((const gchar*) _tmp8_, "") == 0) {
#line 188 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_object_unref0 (note_field);
#line 188 "../src/io/contacts-io-vcard-export-operation.vala"
				continue;
#line 1157 "contacts-io-vcard-export-operation.c"
			}
#line 190 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp9_ = e_vcard_attribute_new (NULL, EVC_NOTE);
#line 190 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = _tmp9_;
#line 191 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp10_ = attr;
#line 191 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp11_ = note_field;
#line 191 "../src/io/contacts-io-vcard-export-operation.vala"
			contacts_io_vcard_export_operation_add_parameters_for_field_details (self, _tmp10_, (FolksAbstractFieldDetails*) _tmp11_);
#line 192 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp12_ = attr;
#line 192 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = NULL;
#line 192 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp13_ = note_field;
#line 192 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp14_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp13_);
#line 192 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp15_ = _tmp14_;
#line 192 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_add_attribute_with_value (vcard, _tmp12_, (const gchar*) _tmp15_);
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
			__vala_EVCardAttribute_free0 (attr);
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (note_field);
#line 1185 "contacts-io-vcard-export-operation.c"
		}
#line 186 "../src/io/contacts-io-vcard-export-operation.vala"
		_g_object_unref0 (_note_field_it);
#line 1189 "contacts-io-vcard-export-operation.c"
	}
}

static void
contacts_io_vcard_export_operation_vcard_set_phone_details (ContactsIoVCardExportOperation* self,
                                                            EVCard* vcard,
                                                            FolksPhoneDetails* details)
{
#line 196 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 196 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 196 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 1204 "contacts-io-vcard-export-operation.c"
	{
		GeeIterator* _phone_field_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = folks_phone_details_get_phone_numbers (details);
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = _tmp0_;
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
		_phone_field_it = _tmp2_;
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
		while (TRUE) {
#line 1220 "contacts-io-vcard-export-operation.c"
			GeeIterator* _tmp3_;
			FolksPhoneFieldDetails* phone_field = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksPhoneFieldDetails* _tmp6_;
			gconstpointer _tmp7_;
			gconstpointer _tmp8_;
			EVCardAttribute* attr = NULL;
			EVCardAttribute* _tmp9_;
			EVCardAttribute* _tmp10_;
			FolksPhoneFieldDetails* _tmp11_;
			EVCardAttribute* _tmp12_;
			FolksPhoneFieldDetails* _tmp13_;
			gconstpointer _tmp14_;
			gconstpointer _tmp15_;
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp3_ = _phone_field_it;
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
				break;
#line 1242 "contacts-io-vcard-export-operation.c"
			}
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp4_ = _phone_field_it;
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
			phone_field = (FolksPhoneFieldDetails*) _tmp5_;
#line 199 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp6_ = phone_field;
#line 199 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp6_);
#line 199 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp8_ = _tmp7_;
#line 199 "../src/io/contacts-io-vcard-export-operation.vala"
			if (g_strcmp0 ((const gchar*) _tmp8_, "") == 0) {
#line 200 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_object_unref0 (phone_field);
#line 200 "../src/io/contacts-io-vcard-export-operation.vala"
				continue;
#line 1262 "contacts-io-vcard-export-operation.c"
			}
#line 202 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp9_ = e_vcard_attribute_new (NULL, EVC_TEL);
#line 202 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = _tmp9_;
#line 203 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp10_ = attr;
#line 203 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp11_ = phone_field;
#line 203 "../src/io/contacts-io-vcard-export-operation.vala"
			contacts_io_vcard_export_operation_add_parameters_for_field_details (self, _tmp10_, (FolksAbstractFieldDetails*) _tmp11_);
#line 204 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp12_ = attr;
#line 204 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = NULL;
#line 204 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp13_ = phone_field;
#line 204 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp14_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp13_);
#line 204 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp15_ = _tmp14_;
#line 204 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_add_attribute_with_value (vcard, _tmp12_, (const gchar*) _tmp15_);
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
			__vala_EVCardAttribute_free0 (attr);
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (phone_field);
#line 1290 "contacts-io-vcard-export-operation.c"
		}
#line 198 "../src/io/contacts-io-vcard-export-operation.vala"
		_g_object_unref0 (_phone_field_it);
#line 1294 "contacts-io-vcard-export-operation.c"
	}
}

static void
contacts_io_vcard_export_operation_vcard_set_postal_address_details (ContactsIoVCardExportOperation* self,
                                                                     EVCard* vcard,
                                                                     FolksPostalAddressDetails* details)
{
#line 208 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 208 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 1309 "contacts-io-vcard-export-operation.c"
	{
		GeeIterator* _postal_field_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = folks_postal_address_details_get_postal_addresses (details);
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = _tmp0_;
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
		_postal_field_it = _tmp2_;
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
		while (TRUE) {
#line 1325 "contacts-io-vcard-export-operation.c"
			GeeIterator* _tmp3_;
			FolksPostalAddressFieldDetails* postal_field = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksPostalAddress* addr = NULL;
			FolksPostalAddressFieldDetails* _tmp6_;
			gconstpointer _tmp7_;
			gconstpointer _tmp8_;
			FolksPostalAddress* _tmp9_;
			EVCardAttribute* attr = NULL;
			EVCardAttribute* _tmp10_;
			EVCardAttribute* _tmp11_;
			FolksPostalAddressFieldDetails* _tmp12_;
			EVCardAttribute* _tmp13_;
			FolksPostalAddress* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			EVCardAttribute* _tmp17_;
			FolksPostalAddress* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			EVCardAttribute* _tmp21_;
			FolksPostalAddress* _tmp22_;
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			EVCardAttribute* _tmp25_;
			FolksPostalAddress* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			EVCardAttribute* _tmp29_;
			FolksPostalAddress* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			EVCardAttribute* _tmp33_;
			FolksPostalAddress* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			EVCardAttribute* _tmp37_;
			FolksPostalAddress* _tmp38_;
			const gchar* _tmp39_;
			const gchar* _tmp40_;
			EVCardAttribute* _tmp41_;
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp3_ = _postal_field_it;
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
				break;
#line 1374 "contacts-io-vcard-export-operation.c"
			}
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp4_ = _postal_field_it;
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
			postal_field = (FolksPostalAddressFieldDetails*) _tmp5_;
#line 211 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp6_ = postal_field;
#line 211 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp6_);
#line 211 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp8_ = _tmp7_;
#line 211 "../src/io/contacts-io-vcard-export-operation.vala"
			addr = (FolksPostalAddress*) _tmp8_;
#line 212 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp9_ = addr;
#line 212 "../src/io/contacts-io-vcard-export-operation.vala"
			if (folks_postal_address_is_empty (_tmp9_)) {
#line 213 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_object_unref0 (postal_field);
#line 213 "../src/io/contacts-io-vcard-export-operation.vala"
				continue;
#line 1398 "contacts-io-vcard-export-operation.c"
			}
#line 215 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp10_ = e_vcard_attribute_new (NULL, EVC_ADR);
#line 215 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = _tmp10_;
#line 216 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp11_ = attr;
#line 216 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp12_ = postal_field;
#line 216 "../src/io/contacts-io-vcard-export-operation.vala"
			contacts_io_vcard_export_operation_add_parameters_for_field_details (self, _tmp11_, (FolksAbstractFieldDetails*) _tmp12_);
#line 218 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp13_ = attr;
#line 218 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp14_ = addr;
#line 218 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp15_ = folks_postal_address_get_po_box (_tmp14_);
#line 218 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp16_ = _tmp15_;
#line 218 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_attribute_add_value (_tmp13_, _tmp16_);
#line 219 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp17_ = attr;
#line 219 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp18_ = addr;
#line 219 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp19_ = folks_postal_address_get_extension (_tmp18_);
#line 219 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp20_ = _tmp19_;
#line 219 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_attribute_add_value (_tmp17_, _tmp20_);
#line 220 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp21_ = attr;
#line 220 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp22_ = addr;
#line 220 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp23_ = folks_postal_address_get_street (_tmp22_);
#line 220 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp24_ = _tmp23_;
#line 220 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_attribute_add_value (_tmp21_, _tmp24_);
#line 221 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp25_ = attr;
#line 221 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp26_ = addr;
#line 221 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp27_ = folks_postal_address_get_locality (_tmp26_);
#line 221 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp28_ = _tmp27_;
#line 221 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_attribute_add_value (_tmp25_, _tmp28_);
#line 222 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp29_ = attr;
#line 222 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp30_ = addr;
#line 222 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp31_ = folks_postal_address_get_region (_tmp30_);
#line 222 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp32_ = _tmp31_;
#line 222 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_attribute_add_value (_tmp29_, _tmp32_);
#line 223 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp33_ = attr;
#line 223 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp34_ = addr;
#line 223 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp35_ = folks_postal_address_get_postal_code (_tmp34_);
#line 223 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp36_ = _tmp35_;
#line 223 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_attribute_add_value (_tmp33_, _tmp36_);
#line 224 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp37_ = attr;
#line 224 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp38_ = addr;
#line 224 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp39_ = folks_postal_address_get_country (_tmp38_);
#line 224 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp40_ = _tmp39_;
#line 224 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_attribute_add_value (_tmp37_, _tmp40_);
#line 226 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp41_ = attr;
#line 226 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = NULL;
#line 226 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_add_attribute (vcard, _tmp41_);
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
			__vala_EVCardAttribute_free0 (attr);
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (postal_field);
#line 1490 "contacts-io-vcard-export-operation.c"
		}
#line 210 "../src/io/contacts-io-vcard-export-operation.vala"
		_g_object_unref0 (_postal_field_it);
#line 1494 "contacts-io-vcard-export-operation.c"
	}
}

static void
contacts_io_vcard_export_operation_vcard_set_role_details (ContactsIoVCardExportOperation* self,
                                                           EVCard* vcard,
                                                           FolksRoleDetails* details)
{
#line 230 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 230 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 1509 "contacts-io-vcard-export-operation.c"
	{
		GeeIterator* _role_field_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = folks_role_details_get_roles (details);
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = _tmp0_;
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
		_role_field_it = _tmp2_;
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
		while (TRUE) {
#line 1525 "contacts-io-vcard-export-operation.c"
			GeeIterator* _tmp3_;
			FolksRoleFieldDetails* role_field = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksRoleFieldDetails* _tmp6_;
			gconstpointer _tmp7_;
			gconstpointer _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			FolksRoleFieldDetails* _tmp17_;
			gconstpointer _tmp18_;
			gconstpointer _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp3_ = _role_field_it;
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
				break;
#line 1546 "contacts-io-vcard-export-operation.c"
			}
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp4_ = _role_field_it;
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
			role_field = (FolksRoleFieldDetails*) _tmp5_;
#line 233 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp6_ = role_field;
#line 233 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp6_);
#line 233 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp8_ = _tmp7_;
#line 233 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp9_ = folks_role_get_title ((FolksRole*) _tmp8_);
#line 233 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp10_ = _tmp9_;
#line 233 "../src/io/contacts-io-vcard-export-operation.vala"
			if (g_strcmp0 (_tmp10_, "") != 0) {
#line 1566 "contacts-io-vcard-export-operation.c"
				EVCardAttribute* _tmp11_;
				FolksRoleFieldDetails* _tmp12_;
				gconstpointer _tmp13_;
				gconstpointer _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
#line 234 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp11_ = e_vcard_attribute_new (NULL, EVC_TITLE);
#line 234 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp12_ = role_field;
#line 234 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp13_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp12_);
#line 234 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp14_ = _tmp13_;
#line 234 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp15_ = folks_role_get_title ((FolksRole*) _tmp14_);
#line 234 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp16_ = _tmp15_;
#line 234 "../src/io/contacts-io-vcard-export-operation.vala"
				e_vcard_add_attribute_with_value (vcard, _tmp11_, _tmp16_);
#line 1587 "contacts-io-vcard-export-operation.c"
			}
#line 237 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp17_ = role_field;
#line 237 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp18_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp17_);
#line 237 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp19_ = _tmp18_;
#line 237 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp20_ = folks_role_get_organisation_name ((FolksRole*) _tmp19_);
#line 237 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp21_ = _tmp20_;
#line 237 "../src/io/contacts-io-vcard-export-operation.vala"
			if (g_strcmp0 (_tmp21_, "") != 0) {
#line 1601 "contacts-io-vcard-export-operation.c"
				EVCardAttribute* _tmp22_;
				FolksRoleFieldDetails* _tmp23_;
				gconstpointer _tmp24_;
				gconstpointer _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
#line 238 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp22_ = e_vcard_attribute_new (NULL, EVC_ORG);
#line 238 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp23_ = role_field;
#line 238 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp24_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp23_);
#line 238 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp25_ = _tmp24_;
#line 238 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp26_ = folks_role_get_organisation_name ((FolksRole*) _tmp25_);
#line 238 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp27_ = _tmp26_;
#line 238 "../src/io/contacts-io-vcard-export-operation.vala"
				e_vcard_add_attribute_with_value (vcard, _tmp22_, _tmp27_);
#line 1622 "contacts-io-vcard-export-operation.c"
			}
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (role_field);
#line 1626 "contacts-io-vcard-export-operation.c"
		}
#line 232 "../src/io/contacts-io-vcard-export-operation.vala"
		_g_object_unref0 (_role_field_it);
#line 1630 "contacts-io-vcard-export-operation.c"
	}
}

static void
contacts_io_vcard_export_operation_vcard_set_url_details (ContactsIoVCardExportOperation* self,
                                                          EVCard* vcard,
                                                          FolksUrlDetails* details)
{
#line 244 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (vcard != NULL);
#line 244 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (details != NULL);
#line 1645 "contacts-io-vcard-export-operation.c"
	{
		GeeIterator* _url_field_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp0_ = folks_url_details_get_urls (details);
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = _tmp0_;
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
		_url_field_it = _tmp2_;
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
		while (TRUE) {
#line 1661 "contacts-io-vcard-export-operation.c"
			GeeIterator* _tmp3_;
			FolksUrlFieldDetails* url_field = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksUrlFieldDetails* _tmp6_;
			gconstpointer _tmp7_;
			gconstpointer _tmp8_;
			EVCardAttribute* attr = NULL;
			EVCardAttribute* _tmp9_;
			EVCardAttribute* _tmp10_;
			FolksUrlFieldDetails* _tmp11_;
			EVCardAttribute* _tmp12_;
			FolksUrlFieldDetails* _tmp13_;
			gconstpointer _tmp14_;
			gconstpointer _tmp15_;
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp3_ = _url_field_it;
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
				break;
#line 1683 "contacts-io-vcard-export-operation.c"
			}
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp4_ = _url_field_it;
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
			url_field = (FolksUrlFieldDetails*) _tmp5_;
#line 247 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp6_ = url_field;
#line 247 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp7_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp6_);
#line 247 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp8_ = _tmp7_;
#line 247 "../src/io/contacts-io-vcard-export-operation.vala"
			if (g_strcmp0 ((const gchar*) _tmp8_, "") == 0) {
#line 248 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_object_unref0 (url_field);
#line 248 "../src/io/contacts-io-vcard-export-operation.vala"
				continue;
#line 1703 "contacts-io-vcard-export-operation.c"
			}
#line 250 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp9_ = e_vcard_attribute_new (NULL, EVC_URL);
#line 250 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = _tmp9_;
#line 251 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp10_ = attr;
#line 251 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp11_ = url_field;
#line 251 "../src/io/contacts-io-vcard-export-operation.vala"
			contacts_io_vcard_export_operation_add_parameters_for_field_details (self, _tmp10_, (FolksAbstractFieldDetails*) _tmp11_);
#line 252 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp12_ = attr;
#line 252 "../src/io/contacts-io-vcard-export-operation.vala"
			attr = NULL;
#line 252 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp13_ = url_field;
#line 252 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp14_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp13_);
#line 252 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp15_ = _tmp14_;
#line 252 "../src/io/contacts-io-vcard-export-operation.vala"
			e_vcard_add_attribute_with_value (vcard, _tmp12_, (const gchar*) _tmp15_);
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
			__vala_EVCardAttribute_free0 (attr);
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (url_field);
#line 1731 "contacts-io-vcard-export-operation.c"
		}
#line 246 "../src/io/contacts-io-vcard-export-operation.vala"
		_g_object_unref0 (_url_field_it);
#line 1735 "contacts-io-vcard-export-operation.c"
	}
}

static void
_vala_EVCardAttributeParam_free (EVCardAttributeParam* self)
{
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
	g_boxed_free (e_vcard_attribute_param_get_type (), self);
#line 1744 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_add_parameters_for_field_details (ContactsIoVCardExportOperation* self,
                                                                     EVCardAttribute* attr,
                                                                     FolksAbstractFieldDetails* field)
{
	GeeCollection* param_values = NULL;
	GeeCollection* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GeeCollection* _tmp2_;
#line 257 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (attr != NULL);
#line 257 "../src/io/contacts-io-vcard-export-operation.vala"
	g_return_if_fail (field != NULL);
#line 259 "../src/io/contacts-io-vcard-export-operation.vala"
	param_values = NULL;
#line 261 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp0_ = folks_abstract_field_details_get_parameter_values (field, FOLKS_ABSTRACT_FIELD_DETAILS_PARAM_TYPE);
#line 261 "../src/io/contacts-io-vcard-export-operation.vala"
	_g_object_unref0 (param_values);
#line 261 "../src/io/contacts-io-vcard-export-operation.vala"
	param_values = _tmp0_;
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp2_ = param_values;
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
	if (_tmp2_ != NULL) {
#line 1774 "contacts-io-vcard-export-operation.c"
		GeeCollection* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp3_ = param_values;
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp4_ = gee_collection_get_is_empty (_tmp3_);
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp5_ = _tmp4_;
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = !_tmp5_;
#line 1786 "contacts-io-vcard-export-operation.c"
	} else {
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp1_ = FALSE;
#line 1790 "contacts-io-vcard-export-operation.c"
	}
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
	if (_tmp1_) {
#line 1794 "contacts-io-vcard-export-operation.c"
		EVCardAttributeParam* param = NULL;
		EVCardAttributeParam* _tmp6_;
		EVCardAttributeParam* _tmp16_;
#line 263 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp6_ = e_vcard_attribute_param_new (EVC_TYPE);
#line 263 "../src/io/contacts-io-vcard-export-operation.vala"
		param = _tmp6_;
#line 1802 "contacts-io-vcard-export-operation.c"
		{
			GeeIterator* _typestr_it = NULL;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp7_ = param_values;
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
			_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
			_typestr_it = _tmp8_;
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
			while (TRUE) {
#line 1815 "contacts-io-vcard-export-operation.c"
				GeeIterator* _tmp9_;
				gchar* typestr = NULL;
				GeeIterator* _tmp10_;
				gpointer _tmp11_;
				EVCardAttributeParam* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp9_ = _typestr_it;
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
				if (!gee_iterator_next (_tmp9_)) {
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
					break;
#line 1830 "contacts-io-vcard-export-operation.c"
				}
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp10_ = _typestr_it;
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp11_ = gee_iterator_get (_tmp10_);
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
				typestr = (gchar*) _tmp11_;
#line 265 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp12_ = param;
#line 265 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp13_ = typestr;
#line 265 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp14_ = g_utf8_strup (_tmp13_, (gssize) -1);
#line 265 "../src/io/contacts-io-vcard-export-operation.vala"
				_tmp15_ = _tmp14_;
#line 265 "../src/io/contacts-io-vcard-export-operation.vala"
				e_vcard_attribute_param_add_value (_tmp12_, _tmp15_);
#line 265 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_free0 (_tmp15_);
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
				_g_free0 (typestr);
#line 1852 "contacts-io-vcard-export-operation.c"
			}
#line 264 "../src/io/contacts-io-vcard-export-operation.vala"
			_g_object_unref0 (_typestr_it);
#line 1856 "contacts-io-vcard-export-operation.c"
		}
#line 266 "../src/io/contacts-io-vcard-export-operation.vala"
		_tmp16_ = param;
#line 266 "../src/io/contacts-io-vcard-export-operation.vala"
		param = NULL;
#line 266 "../src/io/contacts-io-vcard-export-operation.vala"
		e_vcard_attribute_add_param (attr, _tmp16_);
#line 262 "../src/io/contacts-io-vcard-export-operation.vala"
		__vala_EVCardAttributeParam_free0 (param);
#line 1866 "contacts-io-vcard-export-operation.c"
	}
#line 257 "../src/io/contacts-io-vcard-export-operation.vala"
	_g_object_unref0 (param_values);
#line 1870 "contacts-io-vcard-export-operation.c"
}

static gchar*
contacts_io_vcard_export_operation_real_get_description (ContactsOperation* base)
{
	gchar* result;
	ContactsIoVCardExportOperation* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 38 "../src/io/contacts-io-vcard-export-operation.vala"
	self = (ContactsIoVCardExportOperation*) base;
#line 38 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp0_ = self->priv->_description;
#line 38 "../src/io/contacts-io-vcard-export-operation.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 38 "../src/io/contacts-io-vcard-export-operation.vala"
	result = _tmp1_;
#line 38 "../src/io/contacts-io-vcard-export-operation.vala"
	return result;
#line 1890 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_class_init (ContactsIoVCardExportOperationClass * klass,
                                               gpointer klass_data)
{
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	contacts_io_vcard_export_operation_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	g_type_class_adjust_private_offset (klass, &ContactsIoVCardExportOperation_private_offset);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	((ContactsOperationClass *) klass)->execute = (void (*) (ContactsOperation*, GAsyncReadyCallback, gpointer)) contacts_io_vcard_export_operation_real_execute;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	((ContactsOperationClass *) klass)->execute_finish = (void (*) (ContactsOperation*, GAsyncResult*, GError**)) contacts_io_vcard_export_operation_execute_finish;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	CONTACTS_OPERATION_CLASS (klass)->get_description = (gchar* (*) (ContactsOperation*)) contacts_io_vcard_export_operation_real_get_description;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_io_vcard_export_operation_get_property;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_io_vcard_export_operation_finalize;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_IO_VCARD_EXPORT_OPERATION_DESCRIPTION_PROPERTY, contacts_io_vcard_export_operation_properties[CONTACTS_IO_VCARD_EXPORT_OPERATION_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1913 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_instance_init (ContactsIoVCardExportOperation * self,
                                                  gpointer klass)
{
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	self->priv = contacts_io_vcard_export_operation_get_instance_private (self);
#line 30 "../src/io/contacts-io-vcard-export-operation.vala"
	self->priv->vcard_format = EVC_FORMAT_VCARD_30;
#line 35 "../src/io/contacts-io-vcard-export-operation.vala"
	self->priv->avoid_eds = FALSE;
#line 1926 "contacts-io-vcard-export-operation.c"
}

static void
contacts_io_vcard_export_operation_finalize (GObject * obj)
{
	ContactsIoVCardExportOperation * self;
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_IO_TYPE_VCARD_EXPORT_OPERATION, ContactsIoVCardExportOperation);
#line 37 "../src/io/contacts-io-vcard-export-operation.vala"
	_g_free0 (self->priv->_description);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	G_OBJECT_CLASS (contacts_io_vcard_export_operation_parent_class)->finalize (obj);
#line 1939 "contacts-io-vcard-export-operation.c"
}

/**
 * An implementation of {@link Contacts.Io.Exporter} that serializes a contact
 * to the VCard format.
 *
 * Internally, it uses the E.VCard class to implement most of the logic.
 */
 G_GNUC_NO_INLINE static GType
contacts_io_vcard_export_operation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsIoVCardExportOperationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_io_vcard_export_operation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsIoVCardExportOperation), 0, (GInstanceInitFunc) contacts_io_vcard_export_operation_instance_init, NULL };
	GType contacts_io_vcard_export_operation_type_id;
	contacts_io_vcard_export_operation_type_id = g_type_register_static (CONTACTS_IO_TYPE_EXPORT_OPERATION, "ContactsIoVCardExportOperation", &g_define_type_info, 0);
	ContactsIoVCardExportOperation_private_offset = g_type_add_instance_private (contacts_io_vcard_export_operation_type_id, sizeof (ContactsIoVCardExportOperationPrivate));
	return contacts_io_vcard_export_operation_type_id;
}

GType
contacts_io_vcard_export_operation_get_type (void)
{
	static volatile gsize contacts_io_vcard_export_operation_type_id__once = 0;
	if (g_once_init_enter (&contacts_io_vcard_export_operation_type_id__once)) {
		GType contacts_io_vcard_export_operation_type_id;
		contacts_io_vcard_export_operation_type_id = contacts_io_vcard_export_operation_get_type_once ();
		g_once_init_leave (&contacts_io_vcard_export_operation_type_id__once, contacts_io_vcard_export_operation_type_id);
	}
	return contacts_io_vcard_export_operation_type_id__once;
}

static void
_vala_contacts_io_vcard_export_operation_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	ContactsIoVCardExportOperation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_IO_TYPE_VCARD_EXPORT_OPERATION, ContactsIoVCardExportOperation);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
	switch (property_id) {
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
		case CONTACTS_IO_VCARD_EXPORT_OPERATION_DESCRIPTION_PROPERTY:
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
		g_value_take_string (value, contacts_operation_get_description ((ContactsOperation*) self));
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
		break;
#line 1986 "contacts-io-vcard-export-operation.c"
		default:
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/io/contacts-io-vcard-export-operation.vala"
		break;
#line 1992 "contacts-io-vcard-export-operation.c"
	}
}

